package com.junmp.print;

import android.os.Handler;
import android.os.Message;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.view.ViewPager;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.junmp.print.app.UserCache;
import com.junmp.print.presenter.BasePresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.fragment.CheckFragment;
import com.junmp.print.ui.fragment.DataFragment;
import com.junmp.print.ui.fragment.MyFragmentPagerAdapter;
import com.junmp.print.ui.fragment.SetFragment;
import com.junmp.print.ui.matcheck.plan.maintain.MaintainFragmentPagerAdapter;
import com.junmp.print.ui.set.checkmat.CheckMatFragment;
import com.junmp.print.util.UIUtil;
import com.uhf.scanlable.UHfData;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

public class MainActivity extends BaseActivity {
    private long exitTime = 0;

    @BindView(R.id.nav_set_layout)
    LinearLayout setLay;

    @BindView(R.id.nav_set_color)
    View setView;

    @BindView(R.id.nav_set_img)
    ImageView setImg;

    @BindView(R.id.nav_set_text)
    TextView setTv;

    @BindView(R.id.nav_matCheck_layout)
    LinearLayout checkLay;

    @BindView(R.id.nav_matCheck_color)
    View checkView;

    @BindView(R.id.nav_matCheck_img)
    ImageView checkImg;

    @BindView(R.id.nav_matCheck_text)
    TextView checkTv;


    @BindView(R.id.nav_data_layout)
    LinearLayout dataLay;

    @BindView(R.id.nav_data_color)
    View dataView;

    @BindView(R.id.nav_data_img)
    ImageView dataImg;

    @BindView(R.id.nav_data_text)
    TextView dataTv;

    @BindView(R.id.viewpager)
    ViewPager m_vp;

    private int navIndex = 0;
    private int currIndex = 0;
    private Fragment mfragment1;
    private Fragment mfragment2;
    private Fragment mfragment3;
    private List<Fragment> fragmentList;
    private Fragment fg;
    boolean isInit = false;
    private boolean turnFlag = false;

    boolean isrun = false;

    private int MESSAGE_SUCCESS = 0;
    private int MESSAGE_FAIL = 1;
    private String devport = "/dev/ttyMT1";

    public void initView() {
        new Thread(new Runnable() {
            public void run() {
                try {
                    int result = UHfData.UHfGetData.OpenUHf(devport, 57600);
                    if (result == 0) {
                        mHandler.sendEmptyMessage(MESSAGE_SUCCESS);
                    } else {
                        mHandler.sendEmptyMessage(MESSAGE_FAIL);
                    }
                } catch (Exception e) {
                    mHandler.sendEmptyMessage(MESSAGE_FAIL);
                }
            }
        }).start();
        initFragments();
    }

    private ConnectHandler mHandler = new ConnectHandler(this);
    private static class ConnectHandler extends Handler {
        private WeakReference<MainActivity> mReference;
        private MainActivity mActivity;

        ConnectHandler(MainActivity activity) {
            mReference = new WeakReference<MainActivity>(activity);
            mActivity = mReference.get();
        }

        @Override
        public void handleMessage(Message msg) {
            if (msg.what == mActivity.MESSAGE_SUCCESS) {
                Toast.makeText(mActivity.getApplicationContext(), mActivity.getString(R.string.port_connect_success),
                        Toast.LENGTH_SHORT).show();
            } else if (msg.what == mActivity.MESSAGE_FAIL) {
                Toast.makeText(mActivity.getApplicationContext(), mActivity.getString(R.string.port_connect_fail),
                        Toast.LENGTH_SHORT).show();
            }
            super.handleMessage(msg);
        }
    }

    @Override
    protected BasePresenter createPresenter() {
        return null;
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_main;
    }
    /**
     * 初始化页面
     */
    public void initFragments()
    {
        // 初始化四个布局
        mfragment1 = new CheckFragment();
        mfragment2 = new DataFragment();
        mfragment3 = new SetFragment();
        fragmentList = new ArrayList<Fragment>();
        fragmentList.add(mfragment1);
        fragmentList.add(mfragment2);
        fragmentList.add(mfragment3);
        MaintainFragmentPagerAdapter adapter = new MaintainFragmentPagerAdapter(getSupportFragmentManager(), fragmentList);
        m_vp.setAdapter(adapter);
        // 设置菜单栏的点击事件
        m_vp.setOnPageChangeListener(new MyPagerChangeListener());
    }
    /**
     * 设置一个ViewPager的侦听事件，当左右滑动ViewPager时菜单栏被选中状态跟着改变
     *
     */
    public class MyPagerChangeListener implements ViewPager.OnPageChangeListener {

        @Override
        public void onPageScrollStateChanged(int arg0) {
        }

        @Override
        public void onPageScrolled(int arg0, float arg1, int arg2) {
        }

        @Override
        public void onPageSelected(int arg0) {
            switch (arg0) {
                case 0:
                    checkLay.setBackgroundResource(R.color.float_transparent);
                    checkView.setBackgroundResource(R.color.green);
                    checkImg.setImageResource(R.mipmap.nav_check_img_green);
                    checkTv.setTextColor(getResources().getColor(R.color.green));
                    dataLay.setBackgroundResource(R.color.float_transparent);
                    dataView.setBackgroundResource(R.color.float_transparent);
                    dataImg.setImageResource(R.mipmap.nav_data_img);
                    dataTv.setTextColor(getResources().getColor(R.color.text_color));
                    setLay.setBackgroundResource(R.color.float_transparent);
                    setView.setBackgroundResource(R.color.float_transparent);
                    setImg.setImageResource(R.mipmap.nav_set_img);
                    setTv.setTextColor(getResources().getColor(R.color.text_color));
                    break;
                case 1:
                    checkLay.setBackgroundResource(R.color.float_transparent);
                    checkView.setBackgroundResource(R.color.float_transparent);
                    checkImg.setImageResource(R.mipmap.nav_check_img);
                    checkTv.setTextColor(getResources().getColor(R.color.text_color));
                    dataLay.setBackgroundResource(R.color.float_transparent);
                    dataView.setBackgroundResource(R.color.green);
                    dataImg.setImageResource(R.mipmap.nav_data_img_green);
                    dataTv.setTextColor(getResources().getColor(R.color.green));
                    setLay.setBackgroundResource(R.color.float_transparent);
                    setView.setBackgroundResource(R.color.float_transparent);
                    setImg.setImageResource(R.mipmap.nav_set_img);
                    setTv.setTextColor(getResources().getColor(R.color.text_color));
                    break;
                case 2:
                    checkLay.setBackgroundResource(R.color.float_transparent);
                    checkView.setBackgroundResource(R.color.float_transparent);
                    checkImg.setImageResource(R.mipmap.nav_check_img);
                    checkTv.setTextColor(getResources().getColor(R.color.text_color));
                    dataLay.setBackgroundResource(R.color.float_transparent);
                    dataView.setBackgroundResource(R.color.float_transparent);
                    dataImg.setImageResource(R.mipmap.nav_data_img);
                    dataTv.setTextColor(getResources().getColor(R.color.text_color));
                    setLay.setBackgroundResource(R.color.float_transparent);
                    setView.setBackgroundResource(R.color.green);
                    setImg.setImageResource(R.mipmap.nav_set_img_green);
                    setTv.setTextColor(getResources().getColor(R.color.green));
                    break;
            }
        }
    }

    @OnClick({R.id.nav_matCheck_layout,R.id.nav_data_layout,R.id.nav_set_layout})
    public void onViewClick(View view){
        switch (view.getId()) {
//             “校验设置”
            case R.id.nav_matCheck_layout:
                m_vp.setCurrentItem(0);
                break;
//             “UHF设置”
            case R.id.nav_data_layout:
                m_vp.setCurrentItem(1);
                break;
//             “修改密码”
            case R.id.nav_set_layout:
                m_vp.setCurrentItem(2);
                break;
        }
    }


    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {

        if (keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_DOWN) {
            if ((System.currentTimeMillis() - exitTime) > 2000) {
                UIUtil.showToast(UIUtil.getString(R.string.push_again_quit), Toast.LENGTH_SHORT);
                exitTime = System.currentTimeMillis();
            } else {
                UserCache.clear();
                UHfData.UHfGetData.CloseUHf();
                Log.d("BasActivity", "moduleController.close()=======");
                //MainApplication.exit();
                PrintApplication.exit();
            }
            return true;
        }
            return super.onKeyUp(keyCode, event);
        }

        @Override
        protected void onStart () {
            super.onStart();
        }

        @Override
        protected void onStop () {
            super.onStop();
        }

        @Override
        protected void onDestroy () {
            super.onDestroy();
            UHfData.UHfGetData.CloseUHf();
            Log.d("BasActivity", "moduleController.close()=======");
        }


}
