package com.junmp.print.app;

import android.app.ActivityManager;
import android.content.Context;
import android.os.Handler;
import android.support.multidex.MultiDex;

import com.facebook.stetho.Stetho;
import com.junmp.print.PrintApplication;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/1/23
 * 作者：ningzp@junmp.com.cn
 * </pre>
 */

public class MainApplication extends PrintApplication {

    public static MainApplication mInstance;

    /**
     * 上下文对象
     */
    private static Context mContext;

    /**
     * 主线程
     */
    private static Thread mMainThread;

    /**
     * 主线程ID
     */
    private static long mMainThreadId;

    /**
     * 主线程Handler
     */
    private static Handler mHandler;


    @Override
    public void onCreate() {
        super.onCreate();
        mInstance = this ;
        mContext = getApplicationContext();
        mMainThread = Thread.currentThread();
        mMainThreadId = android.os.Process.myTid();
        mHandler = new Handler();
        MultiDex.install(this);
        init();
    }

    public static void exit() {
        getApplicationManager().appExit(mContext);
    }

    public static MainApplication getInstance() {
        return mInstance;
    }

    private void init() {
        //初始化LEAK内存泄露检查工具
        //LeakCanary.install(this);
        //初始化Stetho调试工具
        Stetho.initialize(
                Stetho.newInitializerBuilder(this)
                        .enableDumpapp(Stetho.defaultDumperPluginsProvider(this))
                        .enableWebKitInspector(Stetho.defaultInspectorModulesProvider(this))
                        .build());

    }

    public static String getCurrentProcessName(Context context) {
        int pid = android.os.Process.myPid();
        ActivityManager activityManager = (ActivityManager) context.getSystemService(Context.ACTIVITY_SERVICE);
        for (ActivityManager.RunningAppProcessInfo appProcess : activityManager.getRunningAppProcesses()) {
            if (appProcess.pid == pid) {
                return appProcess.processName;
            }
        }
        return null;
    }

    public static AppManager getApplicationManager() {
        return AppManager.getAppManager();
    }

    public static Context getContext() {
        return mContext;
    }

    public static void setContext(Context mContext) {
        MainApplication.mContext = mContext;
    }

    public static Thread getMainThread() {
        return mMainThread;
    }

    public static void setMainThread(Thread mMainThread) {
        MainApplication.mMainThread = mMainThread;
    }

    public static long getMainThreadId() {
        return mMainThreadId;
    }

    public static void setMainThreadId(long mMainThreadId) {
        MainApplication.mMainThreadId = mMainThreadId;
    }


    public static Handler getMainHandler() {
        return mHandler;
    }

    public static void setMainHandler(Handler mHandler) {
        MainApplication.mHandler = mHandler;
    }
}
