package com.junmp.print.dao.db;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.util.Log;

import org.greenrobot.greendao.AbstractDaoMaster;
import org.greenrobot.greendao.database.StandardDatabase;
import org.greenrobot.greendao.database.Database;
import org.greenrobot.greendao.database.DatabaseOpenHelper;
import org.greenrobot.greendao.identityscope.IdentityScopeType;


// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/**
 * Master of DAO (schema version 11): knows all DAOs.
 */
public class DaoMaster extends AbstractDaoMaster {
    public static final int SCHEMA_VERSION = 11;

    /** Creates underlying database table using DAOs. */
    public static void createAllTables(Database db, boolean ifNotExists) {
        JpTabConfigDao.createTable(db, ifNotExists);
        JpTabCpjyjlDao.createTable(db, ifNotExists);
        JpTabCpjyjljgDao.createTable(db, ifNotExists);
        JpTabDjTempDao.createTable(db, ifNotExists);
        JpTabFwqdDao.createTable(db, ifNotExists);
        JpTabFwqdjyDao.createTable(db, ifNotExists);
        JpTabInoutTmpDao.createTable(db, ifNotExists);
        JpTabMbDao.createTable(db, ifNotExists);
        JpTabSysConfigDao.createTable(db, ifNotExists);
        JpTabTpRfidTempDao.createTable(db, ifNotExists);
        JpTabWzjyDao.createTable(db, ifNotExists);
        TabBzglWzdmDao.createTable(db, ifNotExists);
        TabBzglXtbzdwDao.createTable(db, ifNotExists);
        TabPzmxbWzdmJxcknewPmkDao.createTable(db, ifNotExists);
        TabPzzbJxcknewPmkDao.createTable(db, ifNotExists);
    }

    /** Drops underlying database table using DAOs. */
    public static void dropAllTables(Database db, boolean ifExists) {
        JpTabConfigDao.dropTable(db, ifExists);
        JpTabCpjyjlDao.dropTable(db, ifExists);
        JpTabCpjyjljgDao.dropTable(db, ifExists);
        JpTabDjTempDao.dropTable(db, ifExists);
        JpTabFwqdDao.dropTable(db, ifExists);
        JpTabFwqdjyDao.dropTable(db, ifExists);
        JpTabInoutTmpDao.dropTable(db, ifExists);
        JpTabMbDao.dropTable(db, ifExists);
        JpTabSysConfigDao.dropTable(db, ifExists);
        JpTabTpRfidTempDao.dropTable(db, ifExists);
        JpTabWzjyDao.dropTable(db, ifExists);
        TabBzglWzdmDao.dropTable(db, ifExists);
        TabBzglXtbzdwDao.dropTable(db, ifExists);
        TabPzmxbWzdmJxcknewPmkDao.dropTable(db, ifExists);
        TabPzzbJxcknewPmkDao.dropTable(db, ifExists);
    }

    /**
     * WARNING: Drops all table on Upgrade! Use only during development.
     * Convenience method using a {@link DevOpenHelper}.
     */
    public static DaoSession newDevSession(Context context, String name) {
        Database db = new DevOpenHelper(context, name).getWritableDb();
        DaoMaster daoMaster = new DaoMaster(db);
        return daoMaster.newSession();
    }

    public DaoMaster(SQLiteDatabase db) {
        this(new StandardDatabase(db));
    }

    public DaoMaster(Database db) {
        super(db, SCHEMA_VERSION);
        registerDaoClass(JpTabConfigDao.class);
        registerDaoClass(JpTabCpjyjlDao.class);
        registerDaoClass(JpTabCpjyjljgDao.class);
        registerDaoClass(JpTabDjTempDao.class);
        registerDaoClass(JpTabFwqdDao.class);
        registerDaoClass(JpTabFwqdjyDao.class);
        registerDaoClass(JpTabInoutTmpDao.class);
        registerDaoClass(JpTabMbDao.class);
        registerDaoClass(JpTabSysConfigDao.class);
        registerDaoClass(JpTabTpRfidTempDao.class);
        registerDaoClass(JpTabWzjyDao.class);
        registerDaoClass(TabBzglWzdmDao.class);
        registerDaoClass(TabBzglXtbzdwDao.class);
        registerDaoClass(TabPzmxbWzdmJxcknewPmkDao.class);
        registerDaoClass(TabPzzbJxcknewPmkDao.class);
    }

    public DaoSession newSession() {
        return new DaoSession(db, IdentityScopeType.Session, daoConfigMap);
    }

    public DaoSession newSession(IdentityScopeType type) {
        return new DaoSession(db, type, daoConfigMap);
    }

    /**
     * Calls {@link #createAllTables(Database, boolean)} in {@link #onCreate(Database)} -
     */
    public static abstract class OpenHelper extends DatabaseOpenHelper {
        public OpenHelper(Context context, String name) {
            super(context, name, SCHEMA_VERSION);
        }

        public OpenHelper(Context context, String name, CursorFactory factory) {
            super(context, name, factory, SCHEMA_VERSION);
        }

        @Override
        public void onCreate(Database db) {
            Log.i("greenDAO", "Creating tables for schema version " + SCHEMA_VERSION);
            createAllTables(db, false);
        }
    }

    /** WARNING: Drops all table on Upgrade! Use only during development. */
    public static class DevOpenHelper extends OpenHelper {
        public DevOpenHelper(Context context, String name) {
            super(context, name);
        }

        public DevOpenHelper(Context context, String name, CursorFactory factory) {
            super(context, name, factory);
        }

        @Override
        public void onUpgrade(Database db, int oldVersion, int newVersion) {
            Log.i("greenDAO", "Upgrading schema from version " + oldVersion + " to " + newVersion + " by dropping all tables");
            dropAllTables(db, true);
            onCreate(db);
        }
    }

}
