package com.junmp.print.dao.entity;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Id;
import org.greenrobot.greendao.annotation.Index;
import org.greenrobot.greendao.annotation.NotNull;

import java.io.Serializable;
import java.util.Date;
import java.time.LocalDateTime;
import org.greenrobot.greendao.annotation.Generated;
import org.greenrobot.greendao.annotation.Property;
import org.greenrobot.greendao.annotation.Transient;

import okhttp3.internal.Internal;

/**
 * <pre>
 * 描述：物资校验
 * 版本：1.0
 * 日期：2018/5/10
 * 作者：wangq@junmp.com.cn
 * </pre>
 */
@Entity ( nameInDb = "JP_TAB_WZJY")
public class JpTabWzjy{

    @Id
    @Property(nameInDb = "id")
    private Long id;

     /**
     *物资epc
      */
    @NotNull
    @Index(name = "strwzepc", unique = true)
    @Property(nameInDb = "strwzepc")
    private String strwzepc;

    /**
     *是否扫描完全的数据  Y，完整数据；N，不完整数据
     */
    @Property(nameInDb = "isOk")
    private String isOk;

    /**
     *是否已经导出  Y，导出；N，没有导出
     */
    @Property(nameInDb = "isOut")
    private String isOut;

    /**
     *校验日期
     */
    @Property(nameInDb = "dtDate")
    private Integer dtDate;

    /**
     *物资代码
     */
    @Property(nameInDb = "strwzdm")
    private String strwzdm;

    /**
     *物资名称
     */
    @Property(nameInDb = "strwzmc")
    private String strwzmc;

    /**
     *物资号型
     */
    @Property(nameInDb = "strwzhx")
    private String strwzhx;

    /**
     *箱号
     */
    @Property(nameInDb = "strXiang")
    private String strXiang;

    /**
     *数量
     */
    @Property(nameInDb = "strNum")
    private String strNum;

    /**
     *lsm
     */
    @Property(nameInDb = "lsm")
    private String lsm;

    /**
     *截取有效的epc
     */
    @Property(nameInDb = "strSubEpc")
    private String strSubEpc;

    /**
     *
     */
    @Transient
    private Integer zxs;

    /**
     *

     */
    @Transient
    private Integer y;

    /**
     *
     */
    @Transient
    private Integer n;

@Generated(hash = 1609651166)
public JpTabWzjy(Long id, @NotNull String strwzepc, String isOk, String isOut,
        Integer dtDate, String strwzdm, String strwzmc, String strwzhx,
        String strXiang, String strNum, String lsm, String strSubEpc) {
    this.id = id;
    this.strwzepc = strwzepc;
    this.isOk = isOk;
    this.isOut = isOut;
    this.dtDate = dtDate;
    this.strwzdm = strwzdm;
    this.strwzmc = strwzmc;
    this.strwzhx = strwzhx;
    this.strXiang = strXiang;
    this.strNum = strNum;
    this.lsm = lsm;
    this.strSubEpc = strSubEpc;
}

@Generated(hash = 1723290884)
public JpTabWzjy() {
}

public String getStrwzepc() {
    return this.strwzepc;
}

public void setStrwzepc(String strwzepc) {
    this.strwzepc = strwzepc;
}

public String getIsOk() {
    return this.isOk;
}

public void setIsOk(String isOk) {
    this.isOk = isOk;
}

public String getIsOut() {
    return this.isOut;
}

public void setIsOut(String isOut) {
    this.isOut = isOut;
}

public Integer getDtDate() {
    return this.dtDate;
}

public void setDtDate(Integer dtDate) {
    this.dtDate = dtDate;
}

public String getStrwzdm() {
    return this.strwzdm;
}

public void setStrwzdm(String strwzdm) {
    this.strwzdm = strwzdm;
}

public String getStrwzmc() {
    return this.strwzmc;
}

public void setStrwzmc(String strwzmc) {
    this.strwzmc = strwzmc;
}

public String getStrwzhx() {
    return this.strwzhx;
}

public void setStrwzhx(String strwzhx) {
    this.strwzhx = strwzhx;
}

public String getStrXiang() {
    return this.strXiang;
}

public void setStrXiang(String strXiang) {
    this.strXiang = strXiang;
}

public String getStrNum() {
    return this.strNum;
}

public void setStrNum(String strNum) {
    this.strNum = strNum;
}

public String getLsm() {
    return this.lsm;
}

public void setLsm(String lsm) {
    this.lsm = lsm;
}

public String getStrSubEpc() {
    return this.strSubEpc;
}

public void setStrSubEpc(String strSubEpc) {
    this.strSubEpc = strSubEpc;
}
    public Integer getZxs() {
        return zxs;
    }

    public void setZxs(Integer zxs) {
        this.zxs = zxs;
    }

    public Integer getY() {
        return y;
    }

    public void setY(Integer y) {
        this.y = y;
    }

    public Integer getN() {
        return n;
    }

    public void setN(Integer n) {
        this.n = n;
    }

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }


}
