package com.junmp.print.dao.entity;

import com.junmp.print.dao.service.CommonService;
import com.junmp.print.util.StringUtils;
import com.junmp.print.util.TimeUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/1
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class ProductEpc128{

    CommonService commonService = new CommonService();

    //标签epc长度
    private int iTagLength = 32;

    //EPC中标签类型 1位十进制 0-F 0-单品物资标签，1-箱标签，2-托盘标签，3-货架标签，4-批物资标签
    private String strTagType = "1";


    //EPC中对应企业代码 6位十进制 000000-FFFFFF
    private String strSCCSNo = "FF00FF";

    //数据库中生产企业代码
    private String strSccsCode;

    //生产企业名称
    private String strSCCSName = "";

    //EPC中物资代码, 7位十六进制 000000000-FFFFFFFFF
    private String  strWzNo = "FF000FF";

    //数据库中物资代码 52m码
    private Long iWzNo;

    //数据库中物资代码 对应的NID
    private Long iWzID;

    //物资名称
    private String strWzName;

    //号型名称
    private String strWzHXName = "";

    //epc中包装类型 1位十六进制 0-F 1-外包装，2-中安装，3-内包装，F-零头配箱
    private String strBzType = "1";

    //Epc 中生产日期 5位十六进制 YYMDD
    private String strScrq;

    //数据库 中生产日期
    private Integer dtScrq;

    //Epc中下级包装数量 2位十六进制 00-FF
    private String strXjbzsl = "00";

    //数据库中下级包装数量
    private Integer iXjbzsl;

    //EPC中产品总数量 3位十六进制 000-FFF
    private String strNum = "FFF";

    //数据库中产品总数量
    private Integer iNum;

    //epc中箱序号 4位 0000-FFFF
    private String strXSerialno = "0";

    //数据库中箱序号
    private Integer iXSerialno;

    //epc中箱内序号 4位 0000-FFFF
    private String strXnSerialno = "0";

    //数据库中箱内序号
    private Integer iXnSerialno;

    //epc中校验码 1位十六进制
    private String strJiaoYan = "0";

    //epc
    private String strEpc;

    //起始箱号
    private Integer iStartXNo = 0;

    public int getiTagLength() {
        return iTagLength;
    }

    public void setiTagLength(int iTagLength) {
        this.iTagLength = iTagLength;
    }

    public String getStrTagType() {
        return strTagType;
    }

    public void setStrTagType(String strTagType) {
        this.strTagType = strTagType;
    }

    public String getStrSCCSNo() {
        return strSCCSNo;
    }

    public void setStrSCCSNo(String strSCCSNo) {
        this.strSCCSNo = strSCCSNo;
    }

    public String getStrSccsCode() {
        //return strSccsCode;   将16进制的strSCCSNo转为10进制整数
        return String.valueOf(Integer.parseInt(strSCCSNo,16));
    }

    public void setStrSccsCode(String strSccsCode) {
        //this.strSccsCode = strSccsCode;
        this.strSCCSNo = String.format("%06d", StringUtils.stringToHexString(strSccsCode));//字符串转换成为16进制
    }

    public String getStrSCCSName() {
        return strSCCSName;
    }

    public void setStrSCCSName(String strSCCSName) {
        this.strSCCSName = strSCCSName;
    }

    public String getStrWzNo() {
        return strWzNo;
    }

    public void setStrWzNo(String strWzNo) {
        this.strWzNo = strWzNo;
    }

    public Long getiWzNo() {
        return iWzNo;
    }

    public void setiWzNo(Long iWzNo) {
        this.iWzNo = iWzNo;
    }

    public Long getiWzID() {
        //return iWzID;
        return Long.parseLong(strWzNo,16);
    }

    public void setiWzID(Long iWzID) {
        //this.iWzID = iWzID;
        this.strWzNo = String.format("%07d", Long.toHexString(iWzID));//返回16进制字符串
    }

    public String getStrWzName() {
        return strWzName;
    }

    public void setStrWzName(String strWzName) {
        this.strWzName = strWzName;
    }

    public String getStrWzHXName() {
        return strWzHXName;
    }

    public void setStrWzHXName(String strWzHXName) {
        this.strWzHXName = strWzHXName;
    }

    public String getStrBzType() {
        return strBzType;
    }

    public void setStrBzType(String strBzType) {
        this.strBzType = strBzType;
    }

    public String getStrScrq() {
        return strScrq;
    }

    public void setStrScrq(String strScrq) {
        this.strScrq = strScrq;
    }

    public Integer getDtScrq() {
        try{
            String year = "20" + strScrq.substring(0,2);
            String month =  Integer.toString(Integer.parseInt(strScrq.substring(2,3),16));//16进制转10进制
            String day = strScrq.substring(3,5);
            return TimeUtil.getDateInt(year+"-"+month+"-"+day+" 00:00:00");
        }catch(Exception e){
            return TimeUtil.getDateInt(TimeUtil.getDate()+" 00:00:00");
        }
        //return dtScrq;
    }

    public void setDtScrq(Integer dtScrq) {
        //this.dtScrq = dtScrq; yyyy-MM-dd
        String time = TimeUtil.getDateStringShort(dtScrq);
        String year = time.substring(2,4);
        String month =  Integer.toHexString(Integer.parseInt(strScrq.substring(5,7))) ;//转为16进制
        String day = time.substring(8,10);
        this.strScrq = year+month+day;
    }

    public String getStrXjbzsl() {
        return strXjbzsl;
    }

    public void setStrXjbzsl(String strXjbzsl) {
        this.strXjbzsl = strXjbzsl;
    }

    public Integer getiXjbzsl() {
        //return iXjbzsl;
        return Integer.parseInt(strXjbzsl,16);
    }

    public void setiXjbzsl(Integer iXjbzsl) {
        //this.iXjbzsl = iXjbzsl;
        this.strXjbzsl = String.format("%02d", Integer.toHexString(iXjbzsl));
    }

    public String getStrNum() {
        return strNum;
    }

    public void setStrNum(String strNum) {
        this.strNum = strNum;
    }

    public Integer getiNum() {
        //return iNum;
        return Integer.parseInt(this.strNum,16);
    }

    public void setiNum(Integer iNum) {
        //this.iNum = iNum;
        this.strNum = String.format("%03d", Integer.toHexString(iNum));
    }

    public String getStrXSerialno() {
        return strXSerialno;
    }

    public void setStrXSerialno(String strXSerialno) {
        this.strXSerialno = strXSerialno;
    }

    public Integer getiXSerialno() {
        //return iXSerialno;
        return Integer.parseInt(strXSerialno,16);
    }

    public void setiXSerialno(Integer iXSerialno) {
        //this.iXSerialno = iXSerialno;
        this.strXSerialno = String.format("%04d", Integer.toHexString(iXSerialno));
    }

    public String getStrXnSerialno() {
        return strXnSerialno;
    }

    public void setStrXnSerialno(String strXnSerialno) {
        this.strXnSerialno = strXnSerialno;
    }

    public Integer getiXnSerialno() {
        //return iXnSerialno;
        return Integer.parseInt(strXnSerialno,16);
    }

    public void setiXnSerialno(Integer iXnSerialno) {
        //this.iXnSerialno = iXnSerialno;
        this.strXnSerialno = String.format("%02d", Integer.toHexString(iXnSerialno));
    }

    public String getStrJiaoYan() {
        return strJiaoYan;
    }

    public void setStrJiaoYan(String strJiaoYan) {
        this.strJiaoYan = strJiaoYan;
    }

    public String getStrEpc() {
        return strEpc;
    }

    public void setStrEpc(String strEpc) {
        this.strEpc = strEpc;
    }

    public Integer getiStartXNo() {
        return iStartXNo;
    }

    public void setiStartXNo(Integer iStartXNo) {
        this.iStartXNo = iStartXNo;
    }

    public int getStartXiangNo(){
        return 1;
    }
    public String creatEpc(){
        strEpc = strTagType;
        strEpc += strSCCSNo;
        strEpc += strWzNo;
        strEpc += strBzType;
        strEpc += strScrq;
        strEpc += strXjbzsl;
        strEpc += strNum;
        strEpc += strXSerialno;
        strEpc += strXnSerialno;
        strEpc += strJiaoYan;

        return strEpc;
    }
    public void getInfoFromEpc(){
        switch (iTagLength){
            case 32:
                try{
                    String tagType = strEpc.substring(0,1);
                    if(tagType.equals("1")){
                        this.strTagType = strEpc.substring(0,1);
                        this.strSCCSNo = strEpc.substring(1,7) ;
                        this.strWzNo = strEpc.substring(7,147) ;
                        this.strBzType = strEpc.substring(14,15) ;
                        this.strScrq = strEpc.substring(15,20) ;
                        this.strXjbzsl = strEpc.substring(20,22) ;
                        this.strNum = strEpc.substring(22,25) ;
                        this.strXSerialno = strEpc.substring(25,29) ;
                        this.strXnSerialno = strEpc.substring(29,31) ;
                        this.strJiaoYan = strEpc.substring(31,32) ;
                    }else if(tagType.equals("2")){
                        this.strTagType = strEpc.substring(0,1);
                    }else if(tagType.equals("0")){

                    }

                }catch(Exception e){

                }
        }

    }
    public void getSCCSInfo(){
        try{
            List<TabBzglWzdmBean> listBeans = commonService.getSCCSInfo(this.strSccsCode);
            if(listBeans.size()>0){
                this.strSCCSName = listBeans.get(0).getStrcsmc();
            }
        }catch (Exception e){

        }

    }
    public void getWZHXInfo(){
        try{
            List<TabBzglWzdmBean> listBeans = commonService.getWZHXInfo(String.valueOf(this.iWzID));
            if(listBeans.size()>0){
                this.iWzNo = Long.getLong(listBeans.get(0).getStrwzdm());
                this.strWzName = listBeans.get(0).getStrwzmc();
                this.strWzHXName = listBeans.get(0).getStrwzhx();
            }
        }catch (Exception e){

        }
    }
}