package com.junmp.print.dao.entity;

import com.junmp.print.util.TimeUtil;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/1
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class ProductEpc196{

    //标头信息 十六进制  被装专业固定05
    static String CONSTHEADERINFO = "05";

    //标头信息 二进制
    static String CONSTHEADERINFOBIN = "00000101";

    //版本号 十六进制
    static String CONSTVERSION = "11";

    //版本号 二进制
    static String CONSTVERSIONBIN = "00000101";

    //静态发行机构标志 部队发布
    static String CONSTNILITARYPUBLISHFLAG = "000001";

    //静态发行机构标志 国家发布
    static String CONSTNATIONPUBLISHFLAG = "000010";

    //静态发行机构标志 北约发布
    static String CONSTNATOPUBLISHFLAG = "000011";

    //无源标签6位字段对应表
    String strKeyWords = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    // 无源标签6位字段对应表
    String[] KeyWords = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I",
            "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z" };

    ////1.标头信息 十六进制2位  被装专业固定05
    private String strHexHeaderInfo = CONSTHEADERINFO;

    ////1.标头信息 2进制8位  被装专业固定05
    private String strBinHeaderInfo = CONSTHEADERINFOBIN;

    ////2.发行机构标识 2进制6位  jundui组织机构识别代码为000001
    private String strBinPublishFlag = CONSTNILITARYPUBLISHFLAG;

    //3.组织机构代码 8位  正常组织机构代码
    private String strOrgCode = "";

    //3.组织机构代码 54位  每6位代表一个数字或者字母，位数不够时用每一个字母使用“0”填充；
    //二进制组织机构代码
    private String strBinOrgCode = "";

    //4.品种代码指示长度  十六进制 4位 指示物资代码长度 N*6 = 物资代码长度，默认为6
    private String strHexProductCodeLength = "6";

    //4.品种代码指示长度  二进制 指示物资代码长度 N*6 = 物资代码长度，默认为6
    private String strBinProductCodeLength = "0110";

    //5.物资代码 十六进制 9位，junshi物流信息系统物资代码，转换为十进制后存储，我部使用时占用36位
    private String strHexProductCode = "000000000";

    //5.物资代码 二进制 36位  6-48位，junshi物流信息系统物资代码，转换为十进制后存储，我部使用时占用36位
    private String strBinProductCode = "000000000000000000000000000000000000";

    //6.序列号长度  十六进制 N*6 现固定为A
    private String strHexSerialLength = "A";

    //6.序列号长度  二进制 N*6 现固定为1010
    private String strBinSerialLength = "1010";

    //7.  版本号 十六进制 2位
    private String strHexVersion = CONSTVERSION;

    //7.  版本号 二进制 8位
    private String strBinVersion = CONSTVERSIONBIN;

    //8.标签类型  十六进制 1位 1-箱标签
    private String strHexTagType = "1";

    //8.标签类型  二进制 4位 0001-箱标签
    private String strBinTagType = "0001";

    //9.包装类型  十六进制 1位 （1-外包装，2-中包装，3-内包装，F-零头包装）
    private String strHexPacktype = "1";

    //9.包装类型  二进制 4位 （1-外包装，2-中包装，3-内包装，F-零头包装）
    private String strBinPacktype = "0001";

    //10.下级包装数量  十六进制 2位 最大255
    private String strHexInsidePackNum = "00";

    //10.下级包装数量  二进制 8位 最大255
    private String strBinInsidePackNum = "00000000";

    //11.产品总数量  十六进制 3位 最大4095
    private String strHexProductNum = "000";

    //11.产品总数量  二进制 3位 最大4095
    private String strBinProductNum = "00000000";

    //12.生产线序列号  十六进制 1位 0-E 表示生产组序列号  F表示jun需仓库打印的标签
    private String strHexProductLine = "0";

    //12.生产线序列号  二进制 4位 0-E 表示生产组序列号  F表示jun需仓库打印的标签
    private String strBinProductLine = "0000";

    //13.产品箱序列号  十六进制 3位
    private String strHexPackSerialNo = "000";

    //13.产品箱序列号  二进制 12位
    private String strBinPackSerialNo = "000000000000";

    //14.组别号码  十六进制 1位
    private String strHexGroupNo = "0";

    //14.组别号码  二进制 4位
    private String strBinGroupNo = "0000";


    //15.相同epc中共有几个
    private Integer iZbAll;

    //16.相同epc组别中第几个
    private Integer iZbNo;

    //17.校验码 十六进制 1位
    private String strHexCRCCode = "0";

    //17.校验码 二进制 4位
    private String strBinCRCCode = "0000";

    //18.生产日期 十六进制 6位 YYMMDD
    private String strHexScrq = "120101";

    //18.生产日期 二进制 24位
    private String strBinScrq = "000100100000000100000001";

    private Integer dtScrq;

    public Integer getDtScrq() {
        try{
            String year = "20" + strHexScrq.substring(0,2);
            String month =  strHexScrq.substring(2,4);
            String day = strHexScrq.substring(4,6);
            return TimeUtil.getDateInt(year+"-"+month+"-"+day+" 00-00-00");
        }catch(Exception e){
            return TimeUtil.getDateInt(TimeUtil.getDate());
        }
    }

    public void setDtScrq(Integer dtScrq) {
        this.dtScrq = dtScrq;
    }

    public String[] getKeyWords() {
        return KeyWords;
    }

    public void setKeyWords(String[] keyWords) {
        KeyWords = keyWords;
    }

    public String getStrHexHeaderInfo() {
        return strHexHeaderInfo;
    }

    public void setStrHexHeaderInfo(String strHexHeaderInfo) {
        this.strHexHeaderInfo = strHexHeaderInfo;
    }

    public String getStrBinHeaderInfo() {
        return strBinHeaderInfo;
    }

    public void setStrBinHeaderInfo(String strBinHeaderInfo) {
        this.strBinHeaderInfo = strBinHeaderInfo;
    }

    public String getStrBinPublishFlag() {
        return strBinPublishFlag;
    }

    public void setStrBinPublishFlag(String strBinPublishFlag) {
        this.strBinPublishFlag = strBinPublishFlag;
    }

    public String getStrOrgCode() {
        return strOrgCode;
    }

    public void setStrOrgCode(String strOrgCode) {
        this.strOrgCode = strOrgCode;
    }

    public String getStrBinOrgCode() {
        return strBinOrgCode;
    }

    public void setStrBinOrgCode(String strBinOrgCode) {
        this.strBinOrgCode = strBinOrgCode;
    }

    public String getStrHexProductCodeLength() {
        return strHexProductCodeLength;
    }

    public void setStrHexProductCodeLength(String strHexProductCodeLength) {
        this.strHexProductCodeLength = strHexProductCodeLength;
    }

    public String getStrBinProductCodeLength() {
        return strBinProductCodeLength;
    }

    public void setStrBinProductCodeLength(String strBinProductCodeLength) {
        this.strBinProductCodeLength = strBinProductCodeLength;
    }

    public String getStrHexProductCode() {
        return strHexProductCode;
    }

    public void setStrHexProductCode(String strHexProductCode) {
        this.strHexProductCode = strHexProductCode;
    }

    public String getStrBinProductCode() {
        return strBinProductCode;
    }

    public void setStrBinProductCode(String strBinProductCode) {
        this.strBinProductCode = strBinProductCode;
    }

    public String getStrHexSerialLength() {
        return strHexSerialLength;
    }

    public void setStrHexSerialLength(String strHexSerialLength) {
        this.strHexSerialLength = strHexSerialLength;
    }

    public String getStrBinSerialLength() {
        return strBinSerialLength;
    }

    public void setStrBinSerialLength(String strBinSerialLength) {
        this.strBinSerialLength = strBinSerialLength;
    }

    public String getStrHexVersion() {
        return strHexVersion;
    }

    public void setStrHexVersion(String strHexVersion) {
        this.strHexVersion = strHexVersion;
    }

    public String getStrBinVersion() {
        return strBinVersion;
    }

    public void setStrBinVersion(String strBinVersion) {
        this.strBinVersion = strBinVersion;
    }

    public String getStrHexTagType() {
        return strHexTagType;
    }

    public void setStrHexTagType(String strHexTagType) {
        this.strHexTagType = strHexTagType;
    }

    public String getStrBinTagType() {
        return strBinTagType;
    }

    public void setStrBinTagType(String strBinTagType) {
        this.strBinTagType = strBinTagType;
    }

    public String getStrHexPacktype() {
        return strHexPacktype;
    }

    public void setStrHexPacktype(String strHexPacktype) {
        this.strHexPacktype = strHexPacktype;
    }

    public String getStrBinPacktype() {
        return strBinPacktype;
    }

    public void setStrBinPacktype(String strBinPacktype) {
        this.strBinPacktype = strBinPacktype;
    }

    public String getStrHexInsidePackNum() {
        return strHexInsidePackNum;
    }

    public void setStrHexInsidePackNum(String strHexInsidePackNum) {
        this.strHexInsidePackNum = strHexInsidePackNum;
    }

    public String getStrBinInsidePackNum() {
        return strBinInsidePackNum;
    }

    public void setStrBinInsidePackNum(String strBinInsidePackNum) {
        this.strBinInsidePackNum = strBinInsidePackNum;
    }

    public String getStrHexProductNum() {
        return strHexProductNum;
    }

    public void setStrHexProductNum(String strHexProductNum) {
        this.strHexProductNum = strHexProductNum;
    }

    public String getStrBinProductNum() {
        return strBinProductNum;
    }

    public void setStrBinProductNum(String strBinProductNum) {
        this.strBinProductNum = strBinProductNum;
    }

    public String getStrHexProductLine() {
        return strHexProductLine;
    }

    public void setStrHexProductLine(String strHexProductLine) {
        this.strHexProductLine = strHexProductLine;
    }

    public String getStrBinProductLine() {
        return strBinProductLine;
    }

    public void setStrBinProductLine(String strBinProductLine) {
        this.strBinProductLine = strBinProductLine;
    }

    public String getStrHexPackSerialNo() {
        return strHexPackSerialNo;
    }

    public void setStrHexPackSerialNo(String strHexPackSerialNo) {
        this.strHexPackSerialNo = strHexPackSerialNo;
    }

    public String getStrBinPackSerialNo() {
        return strBinPackSerialNo;
    }

    public void setStrBinPackSerialNo(String strBinPackSerialNo) {
        this.strBinPackSerialNo = strBinPackSerialNo;
    }

    public String getStrHexGroupNo() {
        return strHexGroupNo;
    }

    public void setStrHexGroupNo(String strHexGroupNo) {
        this.strHexGroupNo = strHexGroupNo;
    }

    public String getStrBinGroupNo() {
        return strBinGroupNo;
    }

    public void setStrBinGroupNo(String strBinGroupNo) {
        this.strBinGroupNo = strBinGroupNo;
    }

    public String getStrHexCRCCode() {
        return strHexCRCCode;
    }

    public void setStrHexCRCCode(String strHexCRCCode) {
        this.strHexCRCCode = strHexCRCCode;
    }

    public String getStrBinCRCCode() {
        return strBinCRCCode;
    }

    public void setStrBinCRCCode(String strBinCRCCode) {
        this.strBinCRCCode = strBinCRCCode;
    }

    public String getStrHexScrq() {
        return strHexScrq;
    }

    public void setStrHexScrq(String strHexScrq) {
        this.strHexScrq = strHexScrq;
    }

    public String getStrBinScrq() {
        return strBinScrq;
    }

    public void setStrBinScrq(String strBinScrq) {
        this.strBinScrq = strBinScrq;
    }

    public Integer getiZbAll() {
        int izb = 0;
        switch (Integer.parseInt(strHexGroupNo,16)){
            case 0:
                izb = 1;
                break;
            case 4:
                izb = 2;
                break;
            case 5:
                izb = 2;
                break;
            case 8:
                izb = 4;
                break;
            case 9:
                izb = 4;
                break;
            case 10:
                izb = 4;
                break;
            case 11:
                izb = 4;
                break;
        }
        return izb;
    }

    public void setiZbAll(Integer iZbAll) {
        this.iZbAll = iZbAll;
    }

    public Integer getiZbNo() {
        int izb = 0;
        switch (Integer.parseInt(strHexGroupNo,16)){
            case 0:
                izb = 1;
                break;
            case 4:
                izb = 1;
                break;
            case 5:
                izb = 2;
                break;
            case 8:
                izb = 1;
                break;
            case 9:
                izb = 2;
                break;
            case 10:
                izb = 3;
                break;
            case 11:
                izb = 4;
                break;
        }
        return izb;
    }

    public void setiZbNo(Integer iZbNo) {
        this.iZbNo = iZbNo;

    }

    /***
     * 16进制转为2进制
     *
     * @param hexString
     * @return
     */
    public String hexString2BinString(String hexString){
        String binString = "";
        if (hexString.length() > 0) {
            for (int i = 1; i < hexString.length() + 1; i++) {
                String tempString = "";
                tempString = "0000" + Integer.toBinaryString(Integer.parseInt(hexString.substring(i - 1, i), 16));
                binString += tempString.substring(tempString.length() - 4);
            }
        }
        return binString;
    }

    /***
     * 2进制转为16进制
     *
     * @param binString
     * @return
     */
    public String binString2HexString(String binString){
        String hexString = "";
        int hexLength = (int) Math.ceil((binString.length() * 1.00) / 4);
        binString = "0000" + binString;
        binString = binString.substring(binString.length() - (hexLength * 4));
        if (binString.length() > 0) {
            for (int i = 0; i < hexLength; i++) {
                String tempString = "";
                tempString = binString.substring(i * 4, (i + 1) * 4);
                hexString += KeyWords[Integer.parseInt(tempString, 2)];
            }
        }
        return hexString;
    }

    /**
     *  取得字符串
     *  每6位代表一个数字或者字母，转换为字符串
     *  */
    public String transform6Bin2Character(String str6Bin){
        String characterString = "";
        int characterLength = (int) Math.ceil((str6Bin.length() * 1.00) / 6);
        str6Bin = "000000" + str6Bin;
        str6Bin = str6Bin.substring(str6Bin.length() - (characterLength * 6));
        if (str6Bin.length() > 0) {
            for (int i = 0; i < characterLength; i++) {
                String tempString = "";
                tempString = str6Bin.substring(i * 6, (i + 1) * 6);
                characterString += KeyWords[Integer.parseInt(tempString, 2)];
            }
        }
        return characterString;
    }

    /**
     *  取得字符串
     *
     *  */
    public String transformCharacter26Bin(String strCharacterString){
        // 转为大写
        strCharacterString = strCharacterString.toUpperCase();

        String str6BinString = "";
        if (strCharacterString.length() > 0) {
            for (int i = 1; i < strCharacterString.length() + 1; i++) {
                String tempString = strCharacterString.substring(i - 1, i);
                // 前面加000000，并在字符串找到字符，转为2进制
                tempString = "000000" + Integer.toBinaryString(strKeyWords.indexOf(tempString));
                tempString = tempString.substring(tempString.length() - 6);
                str6BinString += tempString;
            }
        }
        return str6BinString;
    }

    //生成epc 解析epc

    /**
     根据实际epc分解物资信息*/
    public void unPackEpc(String strHexEpc){

        //将epc转为2进制epc编码
        String strBinEpc = this.hexString2BinString(strHexEpc);

        //1.取得表头信息
        this.strBinHeaderInfo = strBinEpc.substring(0,8);
        //this.strHexHeaderInfo = this.binString2HexString(this.strBinHeaderInfo);
        this.strHexHeaderInfo = Integer.toHexString(Integer.parseInt(this.strBinHeaderInfo, 2));

        //被装专用标头信息05
        if(this.strBinHeaderInfo.equals(CONSTHEADERINFOBIN)){

            ////2.发行机构标识 2进制6位  jundui组织机构识别代码为000001
            this.strBinPublishFlag = strBinEpc.substring(8,14);

            //3.组织机构代码
            this.strBinOrgCode = strBinEpc.substring(14,68);
            this.strOrgCode = this.transform6Bin2Character(this.strBinOrgCode);

            //4.品种代码指示长度
            this.strBinProductCodeLength = strBinEpc.substring(68,72);
            this.strHexProductCodeLength = this.binString2HexString(this.strBinProductCodeLength);

            int iProductCodeLength = Integer.parseInt(strHexProductCodeLength,16);

            //5.物资代码
            //修改，根据品种代码只是长度，确定物资代码长度
            this.strBinProductCode = strBinEpc.substring(72,72 + iProductCodeLength*6);
            this.strHexProductCode = this.binString2HexString(this.strBinProductCode);

            //6.序列号长度
            int iSubStart = 72 + iProductCodeLength * 6;
            this.strBinSerialLength =  strBinEpc.substring(iSubStart, iSubStart + 4);
            this.strHexSerialLength = this.binString2HexString(this.strBinSerialLength);
            //转为10进制长度
            int iSerialLength = Integer.parseInt(strHexSerialLength,16);

            //具体序列号内容
            String strSerial = strBinEpc.substring(iSubStart +4,iSubStart + 4 + iSerialLength * 6);

            //7.  版本号
            this.strBinVersion = strSerial.substring(0,8);
            this.strHexVersion = this.binString2HexString(this.strBinVersion);
            //根据版本号来判断，进行不同版本的解析
            if(strHexVersion.equals("11")){

                //8.标签类型
                this.strBinTagType = strSerial.substring(8,12);
                this.strHexTagType = this.binString2HexString(this.strBinTagType);

                //判断当前标签是不是箱标签
                if(this.strHexTagType.equals("1")){

                    //9.包装类型
                    this.strBinPacktype =  strSerial.substring(12,16);
                    this.strHexPacktype =  this.binString2HexString(this.strBinPacktype);

                    //10.下级包装数量
                    this.strBinInsidePackNum = strSerial.substring(16,24);
                    this.strHexInsidePackNum = this.binString2HexString(this.strBinInsidePackNum);

                    //11.产品总数量
                    this.strBinProductNum =  strSerial.substring(24,36);
                    this.strHexProductNum = this.binString2HexString(this.strBinProductNum);

                    //12.生产线序列号
                    this.strBinProductLine = strSerial.substring(36,40);
                    this.strHexProductLine = this.binString2HexString(this.strBinProductLine);

                    //13.产品箱序列号
                    this.strBinPackSerialNo = strSerial.substring(40,52);
                    this.strHexPackSerialNo =  this.binString2HexString(this.strBinPackSerialNo);

                    //14.组别号码
                    this.strBinGroupNo =  strSerial.substring(52,56);
                    this.strHexGroupNo =  this.binString2HexString(this.strBinGroupNo);

                    //15.校验码
                    this.strBinCRCCode = strSerial.substring(56);
                    // this.strHexCRCCode = this.binString2HexString(this.strBinCRCCode);

                    //16.生产日期 十六进制 6位 YYMMDD  ,
                    //iSubStart + 4 + iSerialLength * 6 + 6
                    this.strBinScrq = strBinEpc.substring(iSubStart + 4 + iSerialLength * 6);
                    this.strHexScrq = this.binString2HexString(this.strBinScrq);

                }else{
                    //托盘标签
                }

            }

        }





    }

    /**
     根据物资实际信息生成epc*/
    public String packEpe(){

        String sb = "";
        //1.标头信息
        sb += this.strBinHeaderInfo;
        //2、发行机构标识
        sb += this. strBinPublishFlag;
        //3、组织机构代码
        this.setStrOrgCode("00000000" + this.getStrOrgCode());
        this.setStrOrgCode(this.getStrOrgCode().substring(this.getStrOrgCode().length() - 9));
        this.setStrBinOrgCode(this.transformCharacter26Bin(this.getStrOrgCode()));
        sb += this.getStrBinOrgCode();

        //4、 品种代码指示长度
        sb += this.getStrBinProductCodeLength();

        //5、物资代码
        this.setStrHexProductCode("00000000" + this.getStrHexProductCode());
        this.setStrHexProductCode(this.getStrHexProductCode().substring(this.getStrHexProductCode().length() - 9));
        this.setStrBinProductCode(this.hexString2BinString(this.getStrHexProductCode()));
        sb += this.getStrBinProductCode();

        //6.序列号长度
        sb += this.getStrBinSerialLength();
        //7、版本号
        sb += this.getStrBinVersion();

        //8、标签类型
        this.setStrHexPacktype("0" + this.getStrHexPacktype());
        this.setStrHexPacktype(this.getStrHexPacktype().substring(this.getStrHexPacktype().length() - 1));
        this.setStrBinPacktype(this.hexString2BinString(this.getStrHexPacktype()));
        sb += this.getStrBinPacktype();

        //9.包装类
        sb += this.getStrBinPacktype();

        //10、下级包装数
        this.setStrHexInsidePackNum("00" + this.getStrHexInsidePackNum());
        this.setStrHexInsidePackNum(this.getStrHexInsidePackNum().substring(this.getStrHexInsidePackNum().length() - 2));
        this.setStrBinInsidePackNum(this.hexString2BinString(this.getStrHexInsidePackNum()));
        sb += this.getStrBinInsidePackNum();

        //11、产品总数量
        this.setStrHexProductNum("000" + this.getStrHexProductNum());
        this.setStrHexProductNum(this.getStrHexProductNum().substring(this.getStrHexProductNum().length() - 3));
        this.setStrBinProductNum(this.hexString2BinString(this.getStrHexProductNum()));
        sb += this.getStrBinProductNum();

        //12、生产线序列号
        this.setStrHexProductLine("0" + this.getStrHexProductLine());
        this.setStrHexProductLine(this.getStrHexProductLine().substring(this.getStrHexProductLine().length() - 1));
        this.setStrBinProductLine(this.hexString2BinString(this.getStrHexProductLine()));
        sb += this.getStrBinProductLine();

        //13、产品箱序列号
        this.setStrHexPackSerialNo("000" + this.getStrHexPackSerialNo());
        this.setStrHexPackSerialNo(this.getStrHexPackSerialNo().substring(this.getStrHexPackSerialNo().length() - 3));
        this.setStrBinPackSerialNo(this.hexString2BinString(this.getStrHexPackSerialNo()));
        sb += this.getStrBinPackSerialNo();

        //14、组别号码
        this.setStrHexGroupNo("0" + this.getStrHexGroupNo());
        this.setStrHexGroupNo(this.getStrHexGroupNo().substring(this.getStrHexGroupNo().length() - 1));
        this.setStrBinGroupNo(this.hexString2BinString(this.getStrHexGroupNo()));
        sb += this.getStrBinGroupNo();

        sb += "0000";

        //15、生产日期
        this.setStrHexScrq("000000" + this.getStrHexScrq());
        this.setStrHexScrq(this.getStrHexScrq().substring(this.getStrHexScrq().length() - 1));
        this.setStrBinScrq(this.hexString2BinString(this.getStrHexScrq()));
        sb += this.getStrBinScrq();

        String strRet = "";
        if(sb.length() == 196){
            strRet = this.binString2HexString(sb);
        }

        return strRet;
    }


}
