package com.junmp.print.dao.service;

import android.database.Cursor;

import com.google.common.collect.Lists;
import com.junmp.print.PrintApplication;
import com.junmp.print.dao.db.JpTabFwqdDao;
import com.junmp.print.dao.db.JpTabFwqdjyDao;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabFwqdjy;

import org.greenrobot.greendao.query.DeleteQuery;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/29
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class JpTabFwqdService {

    /**
     * 新增记录(批量)
     */
    public boolean insert(List<JpTabFwqd> list) {
        boolean flag = false;

        try{
            Long id;
            for(int i = 0;i<list.size();i++){
                List<JpTabFwqd> listbean = getYsjhbh(list.get(i));
                if(listbean.size()>0){
                }else{
                    id = PrintApplication.getDaoSession().getJpTabFwqdDao().insert(list.get(i));
                    id += 1;
                    if(i+1 < list.size()){
                        list.get(i+1).setId(id);
                    }
                }

            }
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 新增记录单个
     */
    public boolean insert(JpTabFwqd bean) {
        boolean flag = false;
        try{
            List<JpTabFwqd> listBeans = Lists.newArrayList();
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                    .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                    .where(JpTabFwqdDao.Properties.Lsm.eq(bean.getLsm())).list();
            if(listBeans.size() == 0){//无记录，则插入
                PrintApplication.getDaoSession().getJpTabFwqdDao().insert(bean);
            }
            flag = true;
        } catch(Exception e){
            flag = false;
            e.printStackTrace();
        }
        return flag;
    }

     /**
     * 插入更新
     */
    public boolean inUpdate(JpTabFwqd bean) {

        boolean flag = false;

        try{

            List<JpTabFwqd> listBeans = Lists.newArrayList();
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                    .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                    .where(JpTabFwqdDao.Properties.Lsm.eq(bean.getLsm())).list();
            List<JpTabFwqd> listBeansReal = new ArrayList<>();
            for(JpTabFwqd beanReal : listBeans){
                beanReal.setIsOK(bean.getIsOK());
                beanReal.setJynum(bean.getJynum());
                beanReal.setJydate(bean.getJydate());
                listBeansReal.add(beanReal);
            }
            PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .updateInTx(listBeansReal);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

     /**
     * 插入更新
     */
    public boolean clearUpdate(JpTabFwqd bean) {

        boolean flag = false;

        try{

            List<JpTabFwqd> listBeans = Lists.newArrayList();
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                    .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                    .where(JpTabFwqdDao.Properties.Gznd.eq(bean.getGznd())).list();
            List<JpTabFwqd> listBeansReal = new ArrayList<>();
            for(JpTabFwqd beanReal : listBeans){
                beanReal.setIsOK(bean.getIsOK());
                beanReal.setIsOut(bean.getIsOut());
                beanReal.setJynum(bean.getJynum());
                beanReal.setJydate(bean.getJydate());
                listBeansReal.add(beanReal);
            }
            PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .updateInTx(listBeansReal);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

     /**
     * 发物清单批量插入更新
     */
    public boolean inUpdateList(List<JpTabFwqd> list) {

        boolean flag = false;

        try{

            List<JpTabFwqd> listOld = Lists.newArrayList();
            for(JpTabFwqd bean : list){
                List<JpTabFwqd> listBeans = Lists.newArrayList();
                listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                        .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                        .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                        .where(JpTabFwqdDao.Properties.Lsm.eq(bean.getLsm())).list();

                List<JpTabFwqd> listBeansReal = new ArrayList<>();
                for(JpTabFwqd beanReal : listBeans){
                    beanReal.setIsOK(bean.getIsOK());
                    beanReal.setJynum(bean.getJynum());
                    beanReal.setJydate(bean.getJydate());
                    listBeansReal.add(beanReal);
                }
                listOld.addAll(listBeansReal);
            }
            PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .updateInTx(listOld);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

     /**
     * 导出更新
     */
    public boolean outUpdate(JpTabFwqd bean) {

        boolean flag = false;
        try{
            List<JpTabFwqd> listBeans = Lists.newArrayList();
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                    .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                    .where(JpTabFwqdDao.Properties.Gznd.eq(bean.getGznd()))
                    .where(JpTabFwqdDao.Properties.IsOK.eq("Y")).list();
            List<JpTabFwqd> listBeansReal = new ArrayList<>();
            for(JpTabFwqd beanReal : listBeans){
                beanReal.setIsOut(bean.getIsOut());
                listBeansReal.add(beanReal);
            }
            PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .updateInTx(listBeansReal);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 批量还原更新
     */
    public boolean returnUpdate(List<JpTabFwqd> list) {

        boolean flag = false;

        try{

            List<JpTabFwqd> listOld = Lists.newArrayList();
            for(JpTabFwqd bean : list){
                List<JpTabFwqd> listBeans = Lists.newArrayList();
                listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                        .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                        .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                        .where(JpTabFwqdDao.Properties.Lsm.eq(bean.getLsm()))
                        .where(JpTabFwqdDao.Properties.Jsdwdm.eq(bean.getJsdwdm())).list();

                List<JpTabFwqd> listBeansReal = new ArrayList<>();
                for(JpTabFwqd beanReal : listBeans){
                    beanReal.setIsOK(bean.getIsOK());
                    beanReal.setJynum(bean.getJynum());
                    beanReal.setJydate(bean.getJydate());
                    listBeansReal.add(beanReal);
                }
                listOld.addAll(listBeansReal);
            }
            PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .updateInTx(listOld);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 还原更新
     */
    public boolean returnUpdate(JpTabFwqd bean) {

        boolean flag = false;
        try{
            List<JpTabFwqd> listBeans = Lists.newArrayList();
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                    .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                    .where(JpTabFwqdDao.Properties.Gznd.eq(bean.getGznd()))
                    .where(JpTabFwqdDao.Properties.Swdwdm.eq(bean.getSwdwdm()))
                    .where(JpTabFwqdDao.Properties.Jsdwdm.eq(bean.getJsdwdm())).list();
            List<JpTabFwqd> listBeansReal = new ArrayList<>();
            for(JpTabFwqd beanReal : listBeans){
                beanReal.setIsOut(bean.getIsOut());
                beanReal.setIsOK(bean.getIsOK());
                beanReal.setJynum(bean.getJynum());
                beanReal.setJydate(bean.getJydate());
                listBeansReal.add(beanReal);
            }
            PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .updateInTx(listBeansReal);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *全部删除
     */
    public  boolean deleteAll(String Ysjhbh) {
        boolean flag = false;

        try{
            DeleteQuery deleteQuery= PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Ysjhbh.eq(Ysjhbh)).buildDelete();
            deleteQuery.executeDeleteWithoutDetachingEntities();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *删除校验信息
     */
    public  boolean deleteAllFwqdjy(String Ysjhbh) {
        boolean flag = false;
        try{
            //删除校验信息
            DeleteQuery deleteQueryjy = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(Ysjhbh)).buildDelete();
            deleteQueryjy.executeDeleteWithoutDetachingEntities();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *根据物资编号删除
     */
    public  boolean deleteByLsm(JpTabFwqd bean) {
        boolean flag = false;

        try{
            DeleteQuery deleteQuery= PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                    .where(JpTabFwqdDao.Properties.Jsdwdm.eq(bean.getJsdwdm()))
                    .where(JpTabFwqdDao.Properties.Swdwdm.eq(bean.getSwdwdm()))
                    .where(JpTabFwqdDao.Properties.Lsm.eq(bean.getLsm()))
                    .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                    .buildDelete();
            deleteQuery.executeDeleteWithoutDetachingEntities();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 根据物资编号批量删除
     */
    public boolean deleteByLsm(List<JpTabFwqd> list) {

        boolean flag = false;

        try{

            List<JpTabFwqd> listOld = Lists.newArrayList();
            for(JpTabFwqd bean : list){
                List<JpTabFwqd> listBeans = Lists.newArrayList();
                listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                        .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                        .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                        .where(JpTabFwqdDao.Properties.Lsm.eq(bean.getLsm()))
                        .where(JpTabFwqdDao.Properties.Swdwdm.eq(bean.getSwdwdm()))
                        .where(JpTabFwqdDao.Properties.Jsdwdm.eq(bean.getJsdwdm())).list();
                listOld.addAll(listBeans);
            }
            PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .deleteInTx(listOld);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 获取工作年度
     */
    public List<String> getGznd() {
        List<JpTabFwqd> listBeans = new ArrayList<>();
        listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                .queryRawCreate(" GROUP BY Gznd")
                .list();
        List<String> listGznd=new ArrayList<String>();
        for(JpTabFwqd bean : listBeans){
            listGznd.add(bean.getGznd());
        }
        return listGznd;
    }

    /**
     * 获取运输计划
     */
    public List<String> getYsjhbh() {
        List<JpTabFwqd> listBeans = new ArrayList<>();
        listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                .queryRawCreate(" GROUP BY Ysjhbh")
                .list();
        List<String> listYsjhbh=new ArrayList<String>();
        for(JpTabFwqd bean : listBeans){
            listYsjhbh.add(bean.getYsjhbh());
        }
        return listYsjhbh;
    }

    /**
     * 获取年度运输计划
     */
    public List<String> getYsjhbh(String gznd) {
        List<JpTabFwqd> listBeans = new ArrayList<>();
        listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                .queryRawCreate(" WHERE Gznd = '"+gznd+"' GROUP BY Ysjhbh")
                .list();
        List<String> listYsjhbh=new ArrayList<String>();
        for(JpTabFwqd bean : listBeans){
            listYsjhbh.add(bean.getYsjhbh());
        }
        return listYsjhbh;
    }

    /**
     * 查询是否有重复
     */
    public List<JpTabFwqd> getYsjhbh(JpTabFwqd bean) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
        listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                .where(JpTabFwqdDao.Properties.Gznd.eq(bean.getGznd()))
                .where(JpTabFwqdDao.Properties.Qydwdm.eq(bean.getQydwdm()))
                .where(JpTabFwqdDao.Properties.Wzdm.eq(bean.getWzdm()))
                .where(JpTabFwqdDao.Properties.Hxdm.eq(bean.getHxdm()))
                .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取未导出的运输计划
     */
    public List<String> getYsjhbhIsY() {

        List<JpTabFwqd> listBeans = new ArrayList<>();
        listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                .queryRawCreate(" WHERE isOut = 'N' GROUP BY Ysjhbh")
                .list();
        List<String> listYsjhbh=new ArrayList<String>();
        for(JpTabFwqd bean : listBeans){
            listYsjhbh.add(bean.getYsjhbh());
        }
        return listYsjhbh;
    }

    /**
     * 获取清单号
     */
    public List<JpTabFwqd> getQdh(String strYsjhbh) {

        List<JpTabFwqd> listBeans = new ArrayList<>();
        String sql = "select distinct Qdh,Swdwmc from jp_tab_fwqd where Ysjhbh = '"+strYsjhbh+"' ORDER BY Qdh";
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for (int i = 0; i < cursor.getCount(); i++) {
                //cursor.move(i);
                //cursor.moveToNext();
                cursor.moveToPosition(i);
                JpTabFwqd bean = new JpTabFwqd();
                bean.setQdh(cursor.getString(0));
                bean.setSwdwmc(cursor.getString(1));
                listBeans.add(bean);
            }
        }
        /*listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                .queryRawCreate(" WHERE Ysjhbh = '"+strYsjhbh+"' GROUP BY Qdh")
                .list();*/
        return listBeans;
    }

    /**
     * 获取清单号
     */
    public List<String> getQdh(String strYsjhbh,String strJsdwdm) {

        List<String> listYsjhbh=new ArrayList<String>();
        String sql = "select distinct Qdh from jp_tab_fwqd where Ysjhbh = '"+strYsjhbh+"'and Jsdwdm = '" +strJsdwdm+"'" ;
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for (int i = 0; i < cursor.getCount(); i++) {
                //cursor.move(i);
                //cursor.moveToNext();
                cursor.moveToPosition(i);
                listYsjhbh.add(cursor.getString(0));
            }
        }
        return listYsjhbh;
    }

    /**
     * 获取清单号
     */
    public List<String> getQdhIsOutN(String strYsjhbh) {

        List<String> listYsjhbh=new ArrayList<String>();
        String sql = "select distinct Qdh from jp_tab_fwqd where Ysjhbh = '"+strYsjhbh+"'and isOut = 'N'" ;
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for (int i = 0; i < cursor.getCount(); i++) {
                //cursor.move(i);
                //cursor.moveToNext();
                cursor.moveToPosition(i);
                listYsjhbh.add(cursor.getString(0));
            }
        }
        return listYsjhbh;
    }


    /**
     * 获取清单号
     */
    public List<String> getQdhIsOutN(String strYsjhbh,String strJsdwdm) {

        List<String> listYsjhbh=new ArrayList<String>();
        String sql = "select distinct Qdh from jp_tab_fwqd where Ysjhbh = '"+strYsjhbh+"'and Jsdwdm = '" +strJsdwdm+"'and isOut = 'N'" ;
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for (int i = 0; i < cursor.getCount(); i++) {
                //cursor.move(i);
                //cursor.moveToNext();
                cursor.moveToPosition(i);
                listYsjhbh.add(cursor.getString(0));
            }
        }
        return listYsjhbh;
    }



    /**
     * 获取接收单位
     */
    public List<JpTabFwqd> getJsdw(String strYsjhbh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(" WHERE Ysjhbh = '"+strYsjhbh+"' GROUP BY Jsdwdm")
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }



    /**
     * 获取导出接收单位
     */
    public List<JpTabFwqd> getJsdwByIsOut(String strYsjhbh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(" WHERE Ysjhbh = '"+strYsjhbh+"'AND IsOut = 'N' GROUP BY Jsdwdm")
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取清单号
     */
    public List<JpTabFwqd> getQdh(JpTabFwqd bean) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(" WHERE Ysjhbh = '"+bean.getYsjhbh()+"'AND IsOut = 'N' GROUP BY qdh")
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资名称
     */
    public List<JpTabFwqd> getWzmc(JpTabFwqd bean,boolean distinct) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            String sql = " WHERE Ysjhbh = '"+bean.getYsjhbh()+"'AND Qdh = '"+bean.getQdh()+"'";
            if(distinct) sql = sql + " GROUP BY Wzdm ";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资号型
     */
    public List<JpTabFwqd> getWzhx(JpTabFwqd bean) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            String sql = " WHERE Ysjhbh = '"+bean.getYsjhbh()+"'AND Qdh = '"+bean.getQdh()+"'AND Wzdm = '"+bean.getWzdm()+"' GROUP BY Hxdm";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资号型
     */
    public List<JpTabFwqd> getWzhxOne(JpTabFwqd bean) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            String sql = " WHERE Ysjhbh = '"+bean.getYsjhbh()+"'AND Qdh = '"+bean.getQdh()+"'AND Lsm = '"+bean.getLsm()+"'";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资名称
     */
    public List<JpTabFwqd> getWzmc(String Ysjhbh,String Qdh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'AND Qdh = '"+Qdh+"'AND isOut = 'N'GROUP BY Wzdm";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资名称
     */
    public List<JpTabFwqd> getWzmc(String Ysjhbh,String Swdwdm,String Qdh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'AND Qdh = '"+Qdh+"'AND Swdwdm = '"+Swdwdm+"'AND isOut = 'N' GROUP BY Wzdm";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资名称
     */
    public List<JpTabFwqd> getWzmcByLsm(String Ysjhbh,String Jsdwdm,String Qdh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            //String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'AND Qdh = '"+Qdh+"'AND Jsdwdm = '"+Jsdwdm+"'GROUP BY Lsm";
            String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'";
            if(!Jsdwdm.equals("")){
                sql = sql + "AND Jsdwdm = '" + Jsdwdm + "'";
            }
            if(!Qdh.equals("")){
                sql = sql + "AND Qdh = '" + Qdh + "'";
            }
            sql = sql + "GROUP BY Lsm";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资名称
     */
    public List<JpTabFwqd> getWzmcOKN(String Ysjhbh,String Qdh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'AND Qdh = '"+Qdh+"'AND isOut = 'N' GROUP BY Lsm";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资名称
     */
    public List<JpTabFwqd> getWzmcIsN(String Ysjhbh,String Jsdwdm,String Qdh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            //String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'AND Qdh = '"+Qdh+"'AND Jsdwdm = '"+Jsdwdm+"'AND isOut = 'N' GROUP BY Lsm";
            String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'";
            if(!Jsdwdm.equals("")){
                sql = sql + "AND Jsdwdm = '" + Jsdwdm + "'";
            }
            if(!Qdh.equals("")){
                sql = sql + "AND Qdh = '" + Qdh + "'";
            }
            sql = sql + " AND isOut = 'N' GROUP BY Lsm";

            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 导出的物资名称
     */
    public List<JpTabFwqd> getWzmcIsY(String Ysjhbh,String Jsdwdm,String Qdh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            //String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'AND Qdh = '"+Qdh+"'AND Jsdwdm = '"+Jsdwdm+"'AND isOut = 'Y' GROUP BY Lsm";
            String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'";
            if(!Jsdwdm.equals("")){
                sql = sql + "AND Jsdwdm = '" + Jsdwdm + "'";
            }
            if(!Qdh.equals("")){
                sql = sql + "AND Qdh = '" + Qdh + "'";
            }
            sql = sql + " AND isOut = 'Y' GROUP BY Lsm";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取未扫描完成的物资号型
     */
    public List<JpTabFwqd> getWzhxOKN(String Ysjhbh,String Wzdm,String Qdh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'AND Qdh = '"+Qdh+"'AND Wzdm = '"+Wzdm+"'AND isOut = 'N' GROUP BY Lsm";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资号型
     */
    public List<JpTabFwqd> getWzhx(String Ysjhbh,String Wzdm,String Qdh) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            String sql = " WHERE Ysjhbh = '"+Ysjhbh+"'AND Qdh = '"+Qdh+"'AND Wzdm = '"+Wzdm+"'AND isOut = 'N' GROUP BY Hxdm";
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao()
                    .queryRawCreate(sql)
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资校验数量
     */
    public JpTabFwqd getysjhnum(JpTabFwqd bean) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Qdh.eq(bean.getQdh()))
                    .where(JpTabFwqdDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                    .where(JpTabFwqdDao.Properties.Lsm.eq(bean.getLsm()))
                    .orderDesc(JpTabFwqdDao.Properties.Jydate).list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans.get(0);
    }

    /**
     * 按照日期查询
     */
    public List<JpTabFwqd> selectByData(String startDate , String endDate) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Jydate.ge(startDate))
                    .where(JpTabFwqdDao.Properties.Jydate.le(endDate))
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 按照日期查询
     */
    public List<JpTabFwqd> selectByDataIsN(String startDate , String endDate) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Jydate.ge(startDate))
                    .where(JpTabFwqdDao.Properties.Jydate.le(endDate))
                    .where(JpTabFwqdDao.Properties.IsOut.eq("N"))
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 按照日期查询
     */
    public List<JpTabFwqd> selectByDataIsY(String startDate , String endDate) {

        List<JpTabFwqd> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdDao().queryBuilder()
                    .where(JpTabFwqdDao.Properties.Jydate.ge(startDate))
                    .where(JpTabFwqdDao.Properties.Jydate.le(endDate))
                    .where(JpTabFwqdDao.Properties.IsOut.eq("Y"))
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }
}
