package com.junmp.print.dao.service;

import android.database.Cursor;

import com.junmp.print.PrintApplication;
import com.junmp.print.dao.db.TabBzglWzdmDao;
import com.junmp.print.dao.entity.TabBzglWzdm;
import com.junmp.print.dao.entity.TabBzglWzdmBean;
import com.junmp.print.dao.entity.TabBzglXtbzdw;

import org.greenrobot.greendao.query.DeleteQuery;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/24
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class TabBzglWzdmService {

    private String vie_bzgl_scqyyh = " SELECT DWDM AS FWDWDM, DWFH AS FWDWMC, XSLSGX AS YHDM, \n" +
            "      XSLSXH AS YHXM, XZBZ AS YHKL\n" +
            "FROM TAB_BZGL_XTBZDW\n" +
            "WHERE (DWDM LIKE 'D9%') ";

    private String vie_bzgl_wzdm = " SELECT FLDM, LSM, ZBQMC, JLDW, HXLBBSM, HXLBMC, HX, DMLBBM, DMLBMC, \n" +
            "      WZDM, HXDM, '0' AS ZBSL\n" +
            "FROM TAB_BZGL_WZDM ";

    /**
     * 根据strSCCSCode查询
     */
    public List<TabBzglWzdmBean> getSCCSinfo(String strSCCSCode) {
        List<TabBzglWzdmBean> listBeans = new ArrayList<>();
        String sql = "select FWDWDM as strcsdm ,FWDWMC as strcsmc from( "+vie_bzgl_scqyyh+")as vie_bzgl_scqyyh " +
                "where FWDWDM = '" + strSCCSCode +"'";
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for(int i=0;i<cursor.getCount();i++){
                //cursor.move(i);
                //cursor.moveToNext();
                cursor.moveToPosition(i);
                TabBzglWzdmBean bean = new TabBzglWzdmBean();
                bean.setStrcsdm(cursor.getString(0));
                bean.setStrcsmc(cursor.getString(1));
                listBeans.add(bean);
            }
        }
        return listBeans;
    }

    /**
     * 根据strWzNo查询
     */
    public List<TabBzglWzdmBean> getWZHXInfo(String strWzNo) {
        List<TabBzglWzdmBean> listBeans = new ArrayList<>();
        String sql = "select HXDM as strwzdm ,ZBQMC as strwzmc,HX as strwzhx,LSM from( "+vie_bzgl_wzdm+")as vie_bzgl_wzdm " +
                "where HXDM = '" + strWzNo +"'";
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for(int i=0;i<cursor.getCount();i++){
                //cursor.move(i);
                //cursor.moveToNext();
                cursor.moveToPosition(i);
                TabBzglWzdmBean bean = new TabBzglWzdmBean();
                bean.setStrwzdm(cursor.getString(0));
                bean.setStrwzmc(cursor.getString(1));
                bean.setStrwzhx(cursor.getString(2));
                bean.setLsm(cursor.getString(3));
                listBeans.add(bean);
            }
        }
        return listBeans;
    }

    /**
     * 根据Lsm查询
     */
    public List<TabBzglWzdmBean> getWZHXInfoByLsm(String Lsm) {
        List<TabBzglWzdmBean> listBeans = new ArrayList<>();
        String sql = "select HXDM as strwzdm ,ZBQMC as strwzmc,HX as strwzhx,LSM from( "+vie_bzgl_wzdm+")as vie_bzgl_wzdm " +
                "where LSM = '" + Lsm +"'";
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for(int i=0;i<cursor.getCount();i++){
                //cursor.move(i);
                //cursor.moveToNext();
                cursor.moveToPosition(i);
                TabBzglWzdmBean bean = new TabBzglWzdmBean();
                bean.setStrwzdm(cursor.getString(0));
                bean.setStrwzmc(cursor.getString(1));
                bean.setStrwzhx(cursor.getString(2));
                bean.setLsm(cursor.getString(3));
                listBeans.add(bean);
            }
        }
        return listBeans;
    }

    /**
     *删除全部 tab_bzgl_wzdm
     */
    public  boolean delWzdm() {
        boolean flag = false;
        try{
            PrintApplication.getDaoSession().getTabBzglWzdmDao().deleteAll();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *删除全部 tab_bzgl_xtbzaw
     */
    public  boolean delScqy() {
        boolean flag = false;
        try{
            PrintApplication.getDaoSession().getTabBzglXtbzdwDao().deleteAll();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *新增 tab_bzgl_wzdm
     */
    public  void insertWzdm( TabBzglWzdm tabBzglWzdm) {
        try{
            long listBeans =  PrintApplication.getDaoSession().getTabBzglWzdmDao().insert(tabBzglWzdm);
        } catch(Exception e){
            e.printStackTrace();
        }
    }


    /**
     *新增 tab_bzgl_wzdm
     */
    public  void insertScqy(String csdm,String csmc) {
        try{
            TabBzglXtbzdw tabBzglXtbzdw = new TabBzglXtbzdw();
            tabBzglXtbzdw.setDWDM(csdm);
            tabBzglXtbzdw.setDWFH(csmc);
            long listBeans =  PrintApplication.getDaoSession().getTabBzglXtbzdwDao().insert(tabBzglXtbzdw);
        } catch(Exception e){
            e.printStackTrace();
        }
    }


}
