package com.junmp.print.presenter;


import com.junmp.print.dao.db.DaoSession;
import com.junmp.print.ui.BaseFragment;

import java.lang.ref.Reference;
import java.lang.ref.WeakReference;

/**
 * MVP基类
 */

public class BasePresenter<V> {

    protected Reference<V> mViewRef;

    public void attachView(V view) {
        mViewRef = new WeakReference<V>(view);
    }

    public boolean isViewAttached() {
        return mViewRef != null && mViewRef.get() != null;
    }

    public void detachView() {
        if (mViewRef != null) {
            mViewRef.clear();
            mViewRef = null;
        }
    }

    public V getView() {
        return mViewRef != null ? mViewRef.get() : null;
    }
}
