package com.junmp.print.presenter;

import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Environment;
import android.util.Xml;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabWzjy;
import com.junmp.print.dao.service.JpTabWzjyService;
import com.junmp.print.iview.IDataRandomView;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.XMLUtil;

import org.xmlpull.v1.XmlSerializer;

import java.io.File;
import java.io.FileOutputStream;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/18
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class DataRandomPresenter extends BaseFragmentPresenter<IDataRandomView> {

    public DataRandomPresenter(BaseFragment context) {
        super(context);
    }
    JpTabWzjyService jpTabWzjyService = new JpTabWzjyService();

    /**
     * 随机校验导出
     */
    public void dateOut() {
        try{
            List<JpTabWzjy> list = jpTabWzjyService.getWzJy("Y");
            if(list.size()>0){
                String fileName = XMLUtil.createXmlTags(list);
                if(fileName != null){
                    jpTabWzjyService.delWzJy("Y");
                    mContext.showMessage(String.valueOf(list.size()) + "条数据已导出到" + fileName);
                    scanFile(fileName);
                }else{
                    mContext.showMessage(UIUtil.getString(R.string.export_fail));
                }

            }else{
                mContext.showMessage(UIUtil.getString(R.string.fail_data_out_null));
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }

    }


    /**
     * 随机校验数据清空
     * */
    public void clean(String uploadname) {

        try{
            String fileName = Environment.getExternalStorageDirectory() + "/JPQYHand/"+uploadname+"/";
            File dir = new File(fileName);
            if(!dir.exists()){
                dir.mkdir();
            }
            File[] files = dir.listFiles();
            if(files.length > 0){
                for (int i = 0; i < files.length; i++) {
                    File file = files[i];
                    if(!file.getName().equals("readMe.xml")){
                        file.delete();
                        scanFile(fileName + file.getName());
                    }
                }
            }else{
                mContext.showMessage(UIUtil.getString(R.string.nofile_need_clean));
                return;
            }
        }catch (Exception e){
            mContext.showMessage("Err:"+e.getMessage());
        }
        mContext.showMessage(UIUtil.getString(R.string.file_clean_success));
    }

    /**触发扫描 mtp下的文件，在保存文件到 sd卡下后，不能显示，故这里触发一下扫描机制，让手机连上电脑后，就可以读出文件了
     * @param fileName
     * */
    public void scanFile(String fileName){
        //触发扫描 mtp下的文件，在保存文件到 sd卡下后，不能显示，故这里触发一下扫描机制，让手机连上电脑后，就可以读出文件了
        MediaScannerConnection.scanFile(mContext.getActivity(), new String[]{fileName}, new String[]{"application/octet-stream"}, new MediaScannerConnection.OnScanCompletedListener() {
            @Override
            public void onScanCompleted(final String path, final Uri uri) {
                //your file has been scanned!
            }
        });
    }

}

