package com.junmp.print.presenter;

import com.google.common.collect.Lists;
import com.junmp.print.PrintApplication;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.service.JpTabFwqdService;
import com.junmp.print.iview.ITfMaintainDateView;
import com.junmp.print.ui.BaseActivity;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/18
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class TfMaintainDatePresenter extends BaseActivityPresenter<ITfMaintainDateView> {

    JpTabFwqdService fwqdService = new JpTabFwqdService();


    public TfMaintainDatePresenter(BaseActivity context) {
        super(context);
    }

    public void selectBYdate(String startDay,String endDay,String strCxTyperq) {
        List<JpTabFwqd> listBeans = Lists.newArrayList();
        PrintApplication.getDaoSession().getJpTabFwqdDao().detachAll();//清理缓存

        switch (strCxTyperq){
            case "查询全部":
                listBeans = fwqdService.selectByData(startDay,endDay);
                break;
            case "查询导出":
                listBeans = fwqdService.selectByDataIsY(startDay,endDay);
                break;
            case "查询未导出":
                listBeans = fwqdService.selectByDataIsN(startDay,endDay);
                break;
            default:
                listBeans = fwqdService.selectByData(startDay,endDay);
                break;
        }
        getView().showSearchList(listBeans);
    }

    public void del(List<JpTabFwqd> list) {
        try{
            List<String> doneYsjhbh = new ArrayList<>();
            for(JpTabFwqd bean:list){
                if(!doneYsjhbh.contains(bean.getYsjhbh())){
                    fwqdService.deleteAll(bean.getYsjhbh());
                    fwqdService.deleteAllFwqdjy(bean.getYsjhbh());
                    doneYsjhbh.add(bean.getYsjhbh());
                }
            }
            mContext.showMessage("删除成功");
            getView().clear();

        }catch (Exception e){
            mContext.showMessage("删除失败："+e.getMessage());
        }
    }
}

