package com.junmp.print.presenter;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.service.JpTabFwqdService;
import com.junmp.print.dao.service.JpTabFwqdjyService;
import com.junmp.print.iview.IUnitView;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.UIUtil;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/18
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class UnitPresenter extends BaseFragmentPresenter<IUnitView> {

    public UnitPresenter(BaseFragment context) {
        super(context);
    }
    JpTabFwqdService jpTabFwqdService = new JpTabFwqdService();
    JpTabFwqdjyService jpTabFwqdJyService = new JpTabFwqdjyService();

    /**
     * 获取运输计划
     * */
    public void getCbox_ysjhValue() {
        List<String> listYsjhdh = new ArrayList<>();
        try{
            listYsjhdh =  jpTabFwqdService.getYsjhbh();
            if(listYsjhdh.size()>0){
                getView().showYsjhdh(listYsjhdh);
            }else{
                mContext.showMessage(UIUtil.getString(R.string.ysjh_no_data));
                //运输计划单号为空时，清单号数据也为空
                getView().showJsdw(null);
                getView().showFwqd(null);
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }

    }

    /**
     * 获取接收单位
     */
    public void getCbox_jsdwValue(String strYsjhbh) {
        List<JpTabFwqd> listJsdw = new ArrayList<>();
        try{
            listJsdw =  jpTabFwqdService.getJsdw(strYsjhbh);
            if(listJsdw.size()>0){
                getView().showJsdw(listJsdw);
            }else{
                mContext.showMessage(UIUtil.getString(R.string.jsdw_no_data));
                //物资名称为空时，物资号型也为空
                getView().showFwqd(null);
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }
    }

    /**
     * 获取发物清单号
     */
    public void getCXQdh(String strYsjhbh, String strJsdwdm) {
        List<String> listQdh = new ArrayList<>();
        try{
            listQdh =  jpTabFwqdService.getQdh(strYsjhbh,strJsdwdm);
            if(listQdh.size()>0){
                getView().showFwqd(listQdh);
            }else{
                mContext.showMessage(UIUtil.getString(R.string.fwqd_no_data));
                //运输计划单号为空时，清单号数据也为空
                getView().showFwqd(null);
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }

    }
}
