package com.junmp.print.ui.data.randomcheck;

import android.app.DatePickerDialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.DatePicker;
import android.widget.TextView;

import com.junmp.print.PrintApplication;
import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabWzjy;
import com.junmp.print.dao.entity.JpTabWzjyBean;
import com.junmp.print.iview.IRandomCheckView;
import com.junmp.print.presenter.RandomCheckPresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.ui.matcheck.plan.maintain.date.TfMaintainDateActivity;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;

import java.io.Serializable;
import java.util.Calendar;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：随机校验查询
 * 版本：1.0
 * 日期：2018/4/26
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RandomCheckFragment extends BaseFragment<IRandomCheckView, RandomCheckPresenter> implements IRandomCheckView {


    /**
     * 开始日期
     */
    @BindView(R.id.tv_date_startDate)
    TextView tv_date_startDate;

    /**
     * 结束日期
     */
    @BindView(R.id.tv_date_endDate)
    TextView tv_date_endDate;

    Calendar calendar = Calendar.getInstance();
    //获取系统的日期
    //年
    int yearNow = calendar.get(Calendar.YEAR);
    //月
    int monthNow = calendar.get(Calendar.MONTH)+1;
    //日
    int dayNow = calendar.get(Calendar.DAY_OF_MONTH);

    String startDay = "";
    String endDay = "";


    @Override
    protected RandomCheckPresenter createPresenter() {
        return new RandomCheckPresenter(this);
    }

    @Override
    protected int setView() {
        return R.layout.fragment_data_randomcheck;
    }

    @Override
    protected void init(View view) {
        tv_date_startDate.setText(yearNow + "年" + monthNow + "月" + dayNow + "日");
        tv_date_endDate.setText(yearNow + "年" + monthNow + "月" + dayNow + "日");
        startDay = TimeUtil.getDateString(yearNow,monthNow,dayNow) +"  00-00-00";
        endDay = TimeUtil.getDateString(yearNow,monthNow,dayNow) +"  23-59-59";
    }

    @Override
    protected void intView(View view) {
        /*try{
            Long time = System.currentTimeMillis()/1000;
            JpTabWzjy jpTabWzjy = new JpTabWzjy("epc1","N","N",time.intValue(),"物资代码1","物资名称1","物资号型1","箱号1","5","截取有效的epc1");
            long listBeans =  PrintApplication.getDaoSession().getJpTabWzjyDao().insert(jpTabWzjy);
        }catch(Exception e){
            showMessage(e.getMessage());
        }*/

    }

    @OnClick({R.id.tv_date_startDate,R.id.tv_date_endDate,R.id.bt_data_search})
    public void onViewClick(View v) {
        switch (v.getId()) {
            case R.id.tv_date_startDate:
                getDate(v,tv_date_startDate);
                break;
            case R.id.tv_date_endDate:
                getDate(v,tv_date_endDate);
                break;
            case R.id.bt_data_search:
                search();
                break;
        }
    }

    private void search() {
        showMessage(" ");
        String start = startDay + " 00-00-00";
        String end = endDay + " 00-00-00";
        int startint = TimeUtil.getDateInt(start);
        int endint = TimeUtil.getDateInt(end);
        if(startint > endint){
            showMessage("结束时间必须晚于开始时间！");
            return;
        }
        mPresenter.getWzJyTj( startDay , endDay);

    }

    // 点击事件,日期
    public void getDate(View v,TextView et) {

        new DatePickerDialog(getActivity(), new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                et.setText(year + "年" +  (monthOfYear+1) + "月" + dayOfMonth + "日");
                if(v.getId() == R.id.tv_date_startDate ){
                    startDay = TimeUtil.getDateString(year,monthOfYear+1,dayOfMonth) +"  00-00-00";
                }else if(v.getId() == R.id.tv_date_endDate ){
                    endDay = TimeUtil.getDateString(year,monthOfYear+1,dayOfMonth) +"  23-59-59";
                }

            }
        }, yearNow, monthNow - 1, dayNow).show();
    }

    @Override
    public void showWzJyTj(List<JpTabWzjyBean> listBeans) {
        if(listBeans.size() > 0){
            Bundle bundle = new Bundle();
            bundle.putSerializable("searchList", (Serializable) listBeans);
            jumpToActivityTakeByAndClearTop(RandomCheckListActivity.class,bundle);
        }else{
            showMessage(UIUtil.getString(R.string.search_null));
        }
    }
}

