package com.junmp.print.ui.data.randomcheck;

import android.os.Bundle;
import android.text.Layout;
import android.view.View;
import android.widget.AbsListView;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.ScrollView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabWzjy;
import com.junmp.print.dao.entity.JpTabWzjyBean;
import com.junmp.print.iview.IRandomCheckListView;
import com.junmp.print.presenter.RandomCheckListPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.util.LogUtils;
import com.junmp.print.view.MyListView;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import butterknife.BindView;

/**
 * <pre>
 * 描述：随机校验查询时间查询列表
 * 版本：1.0
 * 日期：2018/5/28
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RandomCheckListActivity extends BaseActivity<IRandomCheckListView,RandomCheckListPresenter> implements IRandomCheckListView {

    @BindView(R.id.data_random_item_lv)
    MyListView lvMatrlItem;

    @BindView(R.id.scrollView)
    ScrollView scrollView;

    private int startIndex;
    private int endIndex;
    private final int pageSize = 15;

    List<JpTabWzjyBean> listItem = new ArrayList<>();
    List<JpTabWzjyBean> listItemFor = new ArrayList<>();

    RandomCheckListAdapter adapter;
    @Override
    protected RandomCheckListPresenter createPresenter() {
        return new RandomCheckListPresenter(this);
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_data_randomcheck_list;
    }

    public void initView() {
        Bundle bundle = getIntent().getExtras();
        List<JpTabWzjyBean> listBeans = (List<JpTabWzjyBean>) bundle.getSerializable("searchList");
        showList(listBeans);
    }

    private void showList(List<JpTabWzjyBean> listBeans) {
        listItem = listBeans;//加载数据
        listItemFor.addAll(getDataService(0,pageSize));
        adapter = new RandomCheckListAdapter(this,listItemFor,onClickListener);
        lvMatrlItem.setAdapter(adapter);
        lvMatrlItem.setScrollView(scrollView);
        lvMatrlItem.setOnScrollListener(new ScrollListener());
        startIndex = 0;
        endIndex = pageSize;
    }

    public final class ScrollListener implements AbsListView.OnScrollListener {
        boolean isLastRow = false;
        @Override
        public void onScrollStateChanged(AbsListView view, int scrollState) {
            LogUtils.e("---->" + scrollState);
            switch (scrollState) {
                case SCROLL_STATE_IDLE://滚到底部
                    if(isLastRow){
                        showMessage("");
                        if(view.getCount() < listItem.size()){//没有加载全部数据的时候
                            startIndex += pageSize;
                            endIndex += pageSize;
                            listItemFor.addAll( getDataService(startIndex, endIndex));
                            adapter.notifyDataSetChanged();

                        }else{
                            showMessage("数据已经加载完全！");
                        }
                        isLastRow = false;
                    }
                    break;
                case SCROLL_STATE_TOUCH_SCROLL:
                    break;
                case SCROLL_STATE_FLING:
                    break;
            }
            //当滚动到最后一行且停止滚动时，执行加载

        }

        @Override
        public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
            if(firstVisibleItem + visibleItemCount == totalItemCount && totalItemCount > 0 ) {
                isLastRow = true;
            }
        }

    }

    /**
     * 加载显示数据
     * @param from
     * @param to
     * @return
     */
    public  List<JpTabWzjyBean> getDataService(int from, int to) {
        List<JpTabWzjyBean> productfor = new ArrayList<>();
        if(to>listItem.size()){
            to = listItem.size();
            endIndex = to;
            startIndex = to -pageSize;
        }
        for (int i = from; i < to; i++) {
            productfor.add(listItem.get(i));
        }
        LogUtils.d("加载数据：" + Integer.toString(productfor.size()));
        return productfor;
    }

    private View.OnClickListener onClickListener = new View.OnClickListener() {

        @Override
        public void onClick(View view) {
            LinearLayout btn = (LinearLayout) view;

            int pos = (Integer) btn.getTag();
            for(int i=0;i<listItem.size();i++){
                if(pos == i){
                    String wzmc = listItem.get(i).getStrwzmc();
                    String wzhx = listItem.get(i).getStrwzhx();
                    mPresenter.getWzJyTjMx(wzmc,wzhx);
                }
            }
        }
    };

    @Override
    public void showWzJyTjMx(List<JpTabWzjyBean> listBeans,String wzmc,String wzhx) {

        Bundle bundle = new Bundle();
        bundle.putString("wzmc",wzmc);
        bundle.putString("wzhx",wzhx);
        bundle.putSerializable("getWzJyTjMxList", (Serializable) listBeans);
        jumpToActivityTakeByAndClearTop(RandomCheckCxjgMxActivity.class,bundle);
    }
}
