package com.junmp.print.ui.data.randomcheck;

import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabWzjy;
import com.junmp.print.dao.entity.JpTabWzjyBean;
import com.junmp.print.util.UIUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/28
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RandomCheckListAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;
    private View.OnClickListener onClickListener;

    public List<JpTabWzjyBean> data;

    public RandomCheckListAdapter(Context context, List<JpTabWzjyBean> data,
                               View.OnClickListener onClickListener) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.onClickListener = onClickListener;
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public Object getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_data_randomcheck_list_item, null);

            holder = new ViewHolder();

            holder.strWzmc_tv = convertView.findViewById(R.id.strWzmc_tv);
            holder.strWzhx_tv = convertView.findViewById(R.id.strWzhx_tv);
            holder.zxs_tv = convertView.findViewById(R.id.zxs_tv);
            holder.n_tv = convertView.findViewById(R.id.n_tv);
            holder.y_tv = convertView.findViewById(R.id.y_tv);
            holder.data_rondomItem_ly = convertView.findViewById(R.id.data_rondomItem_ly);

            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        JpTabWzjyBean mInfo = data.get(position);

        if (mInfo != null) {

            holder.strWzmc_tv.setText(mInfo.getStrwzmc());
            holder.strWzhx_tv.setText(mInfo.getStrwzhx());
            holder.zxs_tv.setText(Integer.toString(mInfo.getZxs()));
            holder.n_tv.setText(Integer.toString(mInfo.getN()));
            holder.y_tv.setText(Integer.toString(mInfo.getY()));
            if(mInfo.getN() != 0){
                holder.data_rondomItem_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
            }
            int[] colors = {Color.WHITE, Color.rgb(219, 238, 244)};//RGB颜色 Color.rgb(219, 238, 244)
            convertView.setBackgroundColor(colors[position % 2]);// 每隔item之间颜色不同
            // 通常将position设置为tag，方便之后判断点击的是哪一个
            holder.data_rondomItem_ly.setTag(position);
            holder.data_rondomItem_ly.setOnClickListener(this.onClickListener);
        }

        return convertView;
    }

    static class ViewHolder {

        TextView strWzmc_tv;

        TextView strWzhx_tv;

        TextView zxs_tv;

        TextView n_tv;

        TextView y_tv;

        LinearLayout data_rondomItem_ly;
    }

}


