package com.junmp.print.ui.fragment;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.Toast;

import com.junmp.print.R;
import com.junmp.print.presenter.BasePresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.ui.matcheck.data.DataActivity;
import com.junmp.print.ui.matcheck.out.outcheck.OutCheckActivity;
import com.junmp.print.ui.matcheck.plan.TfMaintainMenuActivity;
import com.junmp.print.ui.matcheck.random.CheckRandomActivity;
import com.junmp.print.ui.matcheck.repeat.list.RepeatListActivity;
import com.junmp.print.util.UIUtil;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：物资校验主页
 * 版本：1.0
 * 日期：2018/4/24
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class CheckFragment extends BaseFragment {

    @BindView(R.id.matCheck_random)
    LinearLayout randomLay;

    @BindView(R.id.matCheck_transferplan)
    LinearLayout transferplanLay;

    @BindView(R.id.matCheck_out)
    LinearLayout outLay;

    @BindView(R.id.matCheck_repeat)
    LinearLayout repeatLay;

    @BindView(R.id.matCheck_data)
    LinearLayout dataLay;

    @Override
    protected int setView() {
        return R.layout.fragment_matcheck;
    }

    @Override
    protected void init(View view) {

    }

    @Override
    protected void intView(View view) {

    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
    }

    @Override
    protected BasePresenter createPresenter() {
        return null;
    }

    @OnClick({R.id.matCheck_random,R.id.matCheck_transferplan, R.id.matCheck_out,R.id.matCheck_repeat,R.id.matCheck_data})
    public void onViewClick(View view){
        switch (view.getId()) {
//             “物资随机校验”
            case R.id.matCheck_random:
                jumpToActivity(CheckRandomActivity.class);
                break;
//             “运输计划管理菜单页面”
            case R.id.matCheck_transferplan:
                jumpToActivity(TfMaintainMenuActivity.class);
                break;
//             “物资出厂校验”
            case R.id.matCheck_out:
                jumpToActivity(OutCheckActivity.class);
                break;
//             “重复记录文件清单”
            case R.id.matCheck_repeat:
                jumpToActivity(RepeatListActivity.class);
                break;
//             “校验数据上报”
            case R.id.matCheck_data:
                jumpToActivity(DataActivity.class);
                break;
        }
    }
}
