package com.junmp.print.ui.fragment;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.junmp.print.MainActivity;
import com.junmp.print.R;
import com.junmp.print.presenter.BasePresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.ui.matcheck.plan.maintain.MaintainFragmentPagerAdapter;
import com.junmp.print.ui.set.checkmat.CheckMatFragment;
import com.junmp.print.ui.set.password.PasswordFragment;
import com.junmp.print.ui.set.uhf.UhfFragment;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：设置模块
 * 版本：1.0
 * 日期：2018/4/24
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class SetFragment extends BaseFragment {

    @BindView(R.id.tv_item_checkMat)
    TextView checkMatTv;

    @BindView(R.id.tv_item_checkMat_color)
    View checkMatView;

    @BindView(R.id.tv_item_uhf)
    TextView uhfTv;

    @BindView(R.id.tv_item_uhf_color)
    View uhfView;

    @BindView(R.id.tv_item_password)
    TextView passwordTv;

    @BindView(R.id.tv_item_password_color)
    View passwordView;

    @BindView(R.id.setViewpager)
    ViewPager myViewPager;

    private int navIndex = 0;
    private List<Fragment> list;
    private MaintainFragmentPagerAdapter adapter;

    @Override
    protected int setView() {
        return R.layout.fragment_set;
    }

    @Override
    protected void init(View view) {

        // 设置菜单栏的点击事件
        myViewPager.setOnPageChangeListener(new MyPagerChangeListener());

        //把Fragment添加到List集合里面
        list = new ArrayList<>();
        list.add(new CheckMatFragment());
        list.add(new UhfFragment());
        list.add(new PasswordFragment());
        adapter = new MaintainFragmentPagerAdapter(getChildFragmentManager(), list);
        myViewPager.setAdapter(adapter);
        myViewPager.setCurrentItem(0);  //初始化显示第一个页面
        //setNavState(navIndex, 0);  //初始化显示第一个页面
       // myViewPager.setCurrentItem(0);  //初始化显示第一个页面
    }

    @Override
    protected void intView(View view) {

    }

    @Override
    protected BasePresenter createPresenter() {
        return null;
    }

    @OnClick({R.id.tv_item_checkMat,R.id.tv_item_uhf,R.id.tv_item_password})
    public void onViewClick(View view){
        switch (view.getId()) {
//             “校验设置”
            case R.id.tv_item_checkMat:
                myViewPager.setCurrentItem(0);
                break;
//             “UHF设置”
            case R.id.tv_item_uhf:
                /*if (Comm.isrun) {
                    showMessage("请先停止扫描");
                }else{
                    myViewPager.setCurrentItem(1);
                }*/
                myViewPager.setCurrentItem(1);
                break;
//             “修改密码”
            case R.id.tv_item_password:
                /*if (Comm.isrun) {
                    showMessage("请先停止扫描");
                }else{
                    myViewPager.setCurrentItem(2);
                }*/
                myViewPager.setCurrentItem(2);
                break;
        }
    }

    /**
     * 设置一个ViewPager的侦听事件，当左右滑动ViewPager时菜单栏被选中状态跟着改变
     *
     */
    public class MyPagerChangeListener implements ViewPager.OnPageChangeListener {

        @Override
        public void onPageScrollStateChanged(int arg0) {
        }

        @Override
        public void onPageScrolled(int arg0, float arg1, int arg2) {
        }

        @Override
        public void onPageSelected(int arg0) {
            switch (arg0) {
                case 0:
                    checkMatTv.setTextColor(getResources().getColor(R.color.green));
                    checkMatView.setBackgroundResource(R.color.green);
                    uhfTv.setTextColor(getResources().getColor(R.color.text_color));
                    uhfView.setBackgroundResource(R.color.float_transparent);
                    passwordTv.setTextColor(getResources().getColor(R.color.text_color));
                    passwordView.setBackgroundResource(R.color.float_transparent);
                    break;
                case 1:
                    checkMatTv.setTextColor(getResources().getColor(R.color.text_color));
                    checkMatView.setBackgroundResource(R.color.float_transparent);
                    uhfTv.setTextColor(getResources().getColor(R.color.green));
                    uhfView.setBackgroundResource(R.color.green);
                    passwordTv.setTextColor(getResources().getColor(R.color.text_color));
                    passwordView.setBackgroundResource(R.color.float_transparent);
                    break;
                case 2:
                    checkMatTv.setTextColor(getResources().getColor(R.color.text_color));
                    checkMatView.setBackgroundResource(R.color.float_transparent);
                    uhfTv.setTextColor(getResources().getColor(R.color.text_color));
                    uhfView.setBackgroundResource(R.color.float_transparent);
                    passwordTv.setTextColor(getResources().getColor(R.color.green));
                    passwordView.setBackgroundResource(R.color.green);
                    break;
            }
        }
    }
}

