package com.junmp.print.ui.login;

import android.text.TextUtils;
import android.widget.Button;
import android.widget.EditText;

import com.junmp.print.MainActivity;
import com.junmp.print.PrintApplication;
import com.junmp.print.R;
import com.junmp.print.app.UserCache;
import com.junmp.print.dao.entity.JpTabConfig;
import com.junmp.print.ui.BaseActivity;

import butterknife.BindView;

/**
 * <pre>
 * 描述：登录Activity
 * 版本：1.0
 * 日期：2017/8/24
 * 作者：ningzp@junmp.com.cn
 * </pre>
 */
public class LoginActivity extends BaseActivity<ILoginView, LoginPresenter> implements ILoginView {

    @BindView(R.id.et_username)
    EditText mEtUserName;

    @BindView(R.id.et_password)
    EditText mEtPassword;

    @BindView(R.id.login_submit)
    Button mLoginBtn;



    @Override
    protected LoginPresenter createPresenter() {
        return new LoginPresenter(this);
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_login;
    }

    @Override
    public EditText getEtUserName() {
        return mEtUserName;
    }

    @Override
    public EditText getEtPwd() {
        return mEtPassword;
    }

    @Override
    public void init() {
        super.init();
        //如果已经登录，不再登录
        if (!TextUtils.isEmpty(UserCache.getName())) {
            jumpToActivityAndClearTask(MainActivity.class);
        }
        //strwzdm放置的是lsm
        /*PrintApplication.getDaoSession().getJpTabConfigDao().deleteAll();
        JpTabConfig JpTabConfig = new  JpTabConfig(null,2,"csdm","产商代码","admin", "1", 1800, "35991599415", "Y",
                "物资1", "Y", "265/150");

        PrintApplication.getDaoSession().getJpTabConfigDao().insert(JpTabConfig);*/

    }

    @Override
    public void initView() {
        super.initView();
    }

    @Override
    public void initListener() {
        //登录
        mLoginBtn.setOnClickListener(v -> doLogin());
    }

    private void doLogin() {
        mPresenter.login();

    }
}
