package com.junmp.print.ui.matcheck.data;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.view.View;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.presenter.BasePresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.matcheck.data.out.DataOutFragment;
import com.junmp.print.ui.matcheck.data.random.DataRandomFragment;
import com.junmp.print.ui.matcheck.plan.maintain.DateFragment;
import com.junmp.print.ui.matcheck.plan.maintain.MaintainFragmentPagerAdapter;
import com.junmp.print.ui.matcheck.plan.maintain.TfMaintainActivity;
import com.junmp.print.ui.matcheck.plan.maintain.UnitFragment;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class DataActivity extends BaseActivity {

    @BindView(R.id.tv_item_out_color)
    View outView;

    @BindView(R.id.tv_item_out)
    TextView outTv;

    @BindView(R.id.tv_item_random_color)
    View randomView;

    @BindView(R.id.tv_item_random)
    TextView  randomTv;

    @BindView(R.id.outViewpager)
    ViewPager myViewPager;

    private List<Fragment> list;
    private MaintainFragmentPagerAdapter adapter;

    public void initView() {
        myViewPager.setOnPageChangeListener(new MyPagerChangeListener());

        //把Fragment添加到List集合里面
        list = new ArrayList<>();
        list.add(new DataOutFragment());
        list.add(new DataRandomFragment());
        adapter = new MaintainFragmentPagerAdapter(getSupportFragmentManager(), list);
        myViewPager.setAdapter(adapter);
        myViewPager.setCurrentItem(0);  //初始化显示第一个页面
    }

    @Override
    protected BasePresenter createPresenter() {
        return null;
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_check_data;
    }


    @OnClick({R.id.tv_item_out,R.id.tv_item_random})
    public void onViewClick(View v) {
        switch (v.getId()) {
            case R.id.tv_item_out:
                myViewPager.setCurrentItem(0);
                outTv.setTextColor(getResources().getColor(R.color.green));
                outView.setBackgroundResource(R.color.green);
                randomTv.setTextColor(getResources().getColor(R.color.text_color));
                randomView.setBackgroundResource(R.color.float_transparent);
                break;
            case R.id.tv_item_random:
                myViewPager.setCurrentItem(1);
                outTv.setTextColor(getResources().getColor(R.color.text_color));
                outView.setBackgroundResource(R.color.float_transparent);
                randomTv.setTextColor(getResources().getColor(R.color.green));
                randomView.setBackgroundResource(R.color.green);
                break;
        }

    }

    /**
     * 设置一个ViewPager的侦听事件，当左右滑动ViewPager时菜单栏被选中状态跟着改变
     *
     */
    public class MyPagerChangeListener implements ViewPager.OnPageChangeListener {

        @Override
        public void onPageScrollStateChanged(int arg0) {
        }

        @Override
        public void onPageScrolled(int arg0, float arg1, int arg2) {
        }

        @Override
        public void onPageSelected(int arg0) {
            switch (arg0) {
                case 0:
                    outTv.setTextColor(getResources().getColor(R.color.green));
                    outView.setBackgroundResource(R.color.green);
                    randomTv.setTextColor(getResources().getColor(R.color.text_color));
                    randomView.setBackgroundResource(R.color.float_transparent);
                    break;
                case 1:
                    outTv.setTextColor(getResources().getColor(R.color.text_color));
                    outView.setBackgroundResource(R.color.float_transparent);
                    randomTv.setTextColor(getResources().getColor(R.color.green));
                    randomView.setBackgroundResource(R.color.green);
                    break;
            }
        }
    }

}
