package com.junmp.print.ui.matcheck.plan.maintain;

import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.iview.IDateView;
import com.junmp.print.presenter.DatePresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.ui.matcheck.plan.maintain.date.TfMaintainDateActivity;
import com.junmp.print.util.TimeUtil;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：导入日期查询页面
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class DateFragment extends BaseFragment<IDateView, DatePresenter> implements IDateView {

    @BindView(R.id.bt_date_search)
    TextView bt_date_search;

    @BindView(R.id.et_date_startDate)
    TextView et_date_startDate;

    @BindView(R.id.et_date_endDate)
    TextView et_date_endDate;

    @BindView(R.id.type_spinner)
    Spinner spinnerTypes;

    private List<String> data_list;
    private ArrayAdapter<String> arr_adapter;

    Calendar calendar = Calendar.getInstance();
    //获取系统的日期
    //年
    int yearNow = calendar.get(Calendar.YEAR);
    //月
    int monthNow = calendar.get(Calendar.MONTH)+1;
    //日
    int dayNow = calendar.get(Calendar.DAY_OF_MONTH);
    String startDay = "";
    String endDay = "";
    String strCxTyperq = "";

    @Override
    protected DatePresenter createPresenter() {
        return new DatePresenter(this);
    }

    @Override
    protected int setView() {
        return R.layout.fragment_check_tfmaintain_date;
    }

    @Override
    protected void init(View view) {
        et_date_startDate.setText(yearNow + "年" + monthNow + "月" + dayNow + "日");
        et_date_endDate.setText(yearNow + "年" + monthNow + "月" + dayNow + "日");
        startDay = TimeUtil.getDateString(yearNow,monthNow,dayNow);
        endDay = TimeUtil.getDateString(yearNow,monthNow,dayNow);

        spinnerTypes.setOnItemSelectedListener(spnTypesLis);
    }

    @Override
    protected void intView(View view) {

    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
    }

    @OnClick({R.id.bt_date_search,R.id.et_date_startDate,R.id.et_date_endDate})
    public void onViewClick(View view){
        switch (view.getId()) {
            //跳转“导入日期查询结果”
            case R.id.bt_date_search:
                search();
                break;
//             “开始日期”
            case R.id.et_date_startDate:
                getDate(view,et_date_startDate);
                break;
//             “结束日期”
            case R.id.et_date_endDate:
                getDate(view,et_date_endDate);
                break;
        }
    }

    private void search() {
        try{
            showMessage(" ");
            String start = startDay + " 00-00-00";
            String end = endDay + " 00-00-00";
            int startint = TimeUtil.getDateInt(start);
            int endint = TimeUtil.getDateInt(end);
            if(startint > endint){
                showMessage("结束时间必须晚于开始时间！");
                return;
            }
            Bundle bd = new Bundle();
            bd.putString("startDay",startDay);
            bd.putString("endDay",endDay);
            bd.putString("strCxTyperq",strCxTyperq);
            jumpToActivityTakeByAndClearTop(TfMaintainDateActivity.class,bd);

        }catch (Exception e){
            showMessage("Err:" + e.getMessage());
        }

    }

    // 点击事件,日期
    public void getDate(View v,TextView et) {

        new DatePickerDialog(getActivity(), new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                et.setText(year + "年" + (monthOfYear+1) + "月" + dayOfMonth + "日");
                if(v.getId() == R.id.et_date_startDate ){
                    startDay = TimeUtil.getDateString(year,monthOfYear+1,dayOfMonth);
                }else if(v.getId() == R.id.et_date_endDate ){
                    endDay = TimeUtil.getDateString(year,monthOfYear+1,dayOfMonth);
                }
            }
        }, yearNow, monthNow-1, dayNow).show();
    }

    private Spinner.OnItemSelectedListener spnTypesLis = new Spinner.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView parent, View v, int position, long id)
        {
            strCxTyperq = parent.getSelectedItem().toString();

        }
        public void onNothingSelected(AdapterView parent)
        {
            //null
        }
    };
}
