package com.junmp.print.ui.matcheck.plan.maintain.date;

import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.Product_fwqd;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/4
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class TfMaintainDateAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;

    public List<JpTabFwqd> data;
    public TfMaintainDateAdapter(Context context, List<JpTabFwqd> data) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public Object getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_check_tfmaintain_date_item, null);

            holder = new ViewHolder();

            holder.tf_ysjh_tv = convertView.findViewById(R.id.tf_ysjh_tv);
            holder.tf_jsdwmc_tv = convertView.findViewById(R.id.tf_jsdwmc_tv);
            holder.tf_qdh_tv = convertView.findViewById(R.id.tf_qdh_tv);
            holder.tf_swdwmc_tv = convertView.findViewById(R.id.tf_swdwmc_tv);
            holder.tf_zbqmc_tv = convertView.findViewById(R.id.tf_zbqmc_tv);
            holder.tf_hx_tv = convertView.findViewById(R.id.tf_hx_tv);
            holder.tf_pmsl_tv = convertView.findViewById(R.id.tf_pmsl_tv);
            holder.tf_jynum_tv = convertView.findViewById(R.id.tf_jynum_tv);
            holder.tf_item_ly = convertView.findViewById(R.id.tf_item_ly);


            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        JpTabFwqd mInfo = data.get(position);

        if (mInfo != null) {
            holder.tf_ysjh_tv.setText(mInfo.getYsjhbh());
            holder.tf_jsdwmc_tv.setText(mInfo.getJsdwmc());
            holder.tf_qdh_tv.setText(mInfo.getQdh());
            holder.tf_swdwmc_tv.setText(mInfo.getSwdwmc());
            holder.tf_zbqmc_tv.setText(mInfo.getZbqmc());
            holder.tf_hx_tv.setText(mInfo.getHx());
            holder.tf_pmsl_tv.setText(String.valueOf(mInfo.getPmsl()));
            holder.tf_jynum_tv.setText(mInfo.getJynum());
            if(mInfo.getIsOK().equals("N")){
                holder.tf_item_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
            }
        }

        return convertView;
    }

    static class ViewHolder {

        TextView tf_ysjh_tv,tf_jsdwmc_tv,tf_qdh_tv,
                tf_swdwmc_tv,tf_zbqmc_tv,
                tf_hx_tv,tf_pmsl_tv,tf_jynum_tv;
        LinearLayout tf_item_ly;
    }

}

