package com.junmp.print.ui.matcheck.plan.maintain.unit;

import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.MotionEvent;
import android.view.View;
import android.widget.AbsListView;
import android.widget.ListView;
import android.widget.ScrollView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.iview.ITfMaintainUnitView;
import com.junmp.print.presenter.TfMaintainUnitPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.matcheck.plan.maintain.date.TfMaintainDateActivity;
import com.junmp.print.util.LogUtils;
import com.junmp.print.util.UIUtil;
import com.junmp.print.view.MyListView;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：接收单位查询结果
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class TfMaintainUnitActivity  extends BaseActivity<ITfMaintainUnitView,TfMaintainUnitPresenter> implements ITfMaintainUnitView {

    @BindView(R.id.tfUnit_list_lv)
    MyListView item_lv;

    @BindView(R.id.scrollView)
    ScrollView scrollView;

    List<JpTabFwqd> list = new ArrayList<>() ;
    List<JpTabFwqd> listFor = new ArrayList<>() ;

    TfMaintainUnitAdapter adapter;

    private int startIndex;
    private int endIndex;
    private final int pageSize = 15;

    String strYsjhbh,strJsdwdm,strdh,strCxTyperq;
    @Override
    protected TfMaintainUnitPresenter createPresenter() {
        return new TfMaintainUnitPresenter(this);
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_check_tfmaintain_unit;
    }

    @Override
    public void initView() {
         Bundle bd = getIntent().getExtras();
         strYsjhbh = bd.getString("strYsjhbh");
         strJsdwdm = bd.getString("strJsdwdm");
         strdh = bd.getString("strdh");
         strCxTyperq = bd.getString("strCxTyperq");

        item_lv.setScrollView(scrollView);
        startIndex = 0;
        endIndex = pageSize;


        showWaitingDialog("正在加载数据...");
        myThread.start();

    }

    Thread myThread = new Thread(new Runnable() {
        @Override
        public void run() {
            mPresenter.getWzjyByJsdw(strYsjhbh,strJsdwdm,strdh,strCxTyperq);
            //做完以后
        }
    });

    @OnClick({R.id.bt_del})
    public void onViewClick(View v) {
        switch (v.getId()) {
            case R.id.bt_del:
                del();
                break;
        }
    }

    public final class ScrollListener implements AbsListView.OnScrollListener {
        boolean isLastRow = false;
        @Override
        public void onScrollStateChanged(AbsListView view, int scrollState) {
            LogUtils.e("---->" + scrollState);
            switch (scrollState) {
                case SCROLL_STATE_IDLE://滚到底部
                    if(isLastRow){
                        showMessage("");
                        if(view.getCount() < list.size()){//没有加载全部数据的时候

                            startIndex += pageSize;
                            endIndex += pageSize;
                            listFor.addAll( getDataService(startIndex, endIndex));
                            adapter.notifyDataSetChanged();

                        }else{
                            showMessage("数据已经加载完全！");
                        }
                        isLastRow = false;
                    }
                    break;
                case SCROLL_STATE_TOUCH_SCROLL:
                    break;
                case SCROLL_STATE_FLING:
                    break;
            }
            //当滚动到最后一行且停止滚动时，执行加载

        }

        @Override
        public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
            if(firstVisibleItem + visibleItemCount == totalItemCount && totalItemCount > 0 ) {
                isLastRow = true;
            }
        }

    }

    /**
     * 加载显示数据
     * @param from
     * @param to
     * @return
     */
    public List<JpTabFwqd> getDataService(int from, int to) {
        List<JpTabFwqd> productfor = new ArrayList<>();
        if(to>list.size()){
            to = list.size();
            endIndex = to;
            startIndex = to -pageSize;
        }
        for (int i = from; i < to; i++) {
            productfor.add(list.get(i));
        }
        LogUtils.d("加载数据：" + Integer.toString(productfor.size()));
        return productfor;
    }

    private void del() {
        if(list.size()>0 && list != null){
            String title = UIUtil.getString(R.string.system_note);
            String message = UIUtil.getString(R.string.delete_ysjhdata);
            showDialog(title,message,new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    mPresenter.del(list);//删除运输计划
                }
            },null);
        }else{
            showMessage("并无可删除的运输计划");
        }

    }

    @Override
    public void showSearchList(List<JpTabFwqd> listBeans) {
        list = listBeans;
        Message msgUp = new Message();
        msgUp.what = 1;
        mHandleCount.sendMessage(msgUp);
    }

    private void show() {
        try{
            if(list.size()>0){
                listFor.addAll(getDataService(0,pageSize));
                adapter = new TfMaintainUnitAdapter(this,listFor);
                item_lv.setAdapter(adapter);
                item_lv.setOnScrollListener(new ScrollListener());
                //setListViewHeightBasedOnChildren(item_lv);
            }else{
                showMessage(UIUtil.getString(R.string.search_null));
            }
        }catch (Exception e){
            showMessage("Err:"+e.getMessage());
        }finally {
            hideWaitingDialog();
        }
    }

    @Override
    public void clear() {
        list.clear();
        listFor.clear();
        adapter.notifyDataSetChanged();
        item_lv.setAdapter(adapter);
    }

    private Handler mHandleCount = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            switch (msg.what) {
                case 1://showSearchList
                    show();
                    break;
            }
        }


    };
}
