package com.junmp.print.ui.matcheck.random;

import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.entity.ProductEpcBean;
import com.junmp.print.util.UIUtil;

import java.util.List;
import java.util.Map;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/22
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class CheckRandomAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;
    private View.OnClickListener onClickListener;

    public List<ProductEpc> data;

    public CheckRandomAdapter(Context context, List<ProductEpc> data,
                               View.OnClickListener onClickListener) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.onClickListener = onClickListener;
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public ProductEpc getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_check_random_item, null);

            holder = new ViewHolder();

            holder.wzName_tv = convertView.findViewById(R.id.wzName_tv);
            holder.wzhxName_tv = convertView.findViewById(R.id.wzhxName_tv);
            holder.total_tv = convertView.findViewById(R.id.total_tv);
            holder.scan_notAll_tv = convertView.findViewById(R.id.scan_notAll_tv);
            holder.scan_all_tv = convertView.findViewById(R.id.scan_all_tv);
            holder.tj_item_ly = convertView.findViewById(R.id.tj_item_ly);

            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        ProductEpc pro = data.get(position);

        if (pro != null) {

            holder.wzName_tv.setText(pro.getStrWzName());
            if(pro.getStrBzType().equals("F")){
                holder.wzhxName_tv.setText("");
            }else{
                holder.wzhxName_tv.setText(pro.getStrWzHXName());
            }

            holder.total_tv.setText(String.valueOf(pro.getHj()));
            holder.scan_notAll_tv.setText(String.valueOf(pro.getWq()));
            holder.scan_all_tv.setText(String.valueOf(pro.getSq()));

            if(pro.getWq() ==  0){
                holder.tj_item_ly.setBackgroundColor(UIUtil.getColor(R.color.white));
            }else{
                holder.tj_item_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
            }
           /* int[] colors = {Color.WHITE, Color.rgb(219, 238, 244)};//RGB颜色 Color.rgb(219, 238, 244)
            convertView.setBackgroundColor(colors[position % 2]);// 每隔item之间颜色不同*/
            // 通常将position设置为tag，方便之后判断点击的是哪一个
            holder.tj_item_ly.setTag(position);
            holder.tj_item_ly.setOnClickListener(this.onClickListener);
        }

        return convertView;
    }

    static class ViewHolder {
        TextView wzName_tv,wzhxName_tv,total_tv,scan_notAll_tv,scan_all_tv;
        LinearLayout tj_item_ly;
    }

    public void updataView(int posi, ListView listView,ProductEpc pro) {
        int visibleFirstPosi = listView.getFirstVisiblePosition();
        int visibleLastPosi = listView.getLastVisiblePosition();
        if (posi >= visibleFirstPosi && posi <= visibleLastPosi) {
            View view = listView.getChildAt(posi - visibleFirstPosi);
            ViewHolder holder = (ViewHolder) view.getTag();

            if (pro != null) {

                holder.wzName_tv.setText(pro.getStrWzName());
                if (pro.getStrBzType().equals("F")) {
                    holder.wzhxName_tv.setText("");
                } else {
                    holder.wzhxName_tv.setText(pro.getStrWzHXName());
                }

                holder.total_tv.setText(String.valueOf(pro.getHj()));
                holder.scan_notAll_tv.setText(String.valueOf(pro.getWq()));
                holder.scan_all_tv.setText(String.valueOf(pro.getSq()));

                if (pro.getWq() == 0) {
                    holder.tj_item_ly.setBackgroundColor(UIUtil.getColor(R.color.white));
                } else {
                    holder.tj_item_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
                }
                data.set(posi, pro);
            }
        }
    }

}



