package com.junmp.print.ui.matcheck.repeat.list;

import android.os.Bundle;
import android.os.Environment;
import android.text.Layout;
import android.util.Xml;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabFwqdBean;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.entity.Product_fwqd;
import com.junmp.print.dao.entity.TabBzglWzdm;
import com.junmp.print.iview.IRepeatListView;
import com.junmp.print.presenter.RepeatListPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.matcheck.out.outcount.OutCountAdapter;
import com.junmp.print.ui.matcheck.repeat.scan.RepeatScanActivity;
import com.junmp.print.util.UIUtil;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：重复记录文件清单
 * 版本：1.0
 * 日期：2018/4/26
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RepeatListActivity extends BaseActivity<IRepeatListView,RepeatListPresenter> implements IRepeatListView {

    @BindView(R.id.bt_scan)
    TextView bt_scan;

    @BindView(R.id.check_random_item_lv)
    ListView item_lv;

    List<String> fileNameList = new ArrayList<>();
    String v_pathName = Environment.getExternalStorageDirectory()+"/JPQYHand/ErrorXml/";
    String v_fileName = "";

    public void initView() {
        importWzdm();
    }

    @Override
    protected RepeatListPresenter createPresenter() {
        return new RepeatListPresenter(this);
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_check_repeat_list;
    }

    private void importWzdm() {
        //showWaitingDialog("正在查找文件...");
        try{
            File dir = new File(v_pathName);
            if(!dir.exists()){
                dir.mkdirs();
            }
            File[] files = dir.listFiles();
            if(files.length > 0){

                for (int i = 0; i < files.length; i++) {
                    File file = files[i];
                    if(!file.getName().equals("readMe.xml")){
                        fileNameList.add(file.getName());
                    }
                }

                item_lv.setAdapter(new RepeatListAdapter(this,fileNameList,onClickListener));
                setListViewHeightBasedOnChildren(item_lv);

            }else{
                showMessage(UIUtil.getString(R.string.nofile));
                return;
            }
        }catch (Exception e){
            showMessage("Err:"+e.getMessage());
        }
        //hideWaitingDialog();
    }

    @OnClick({R.id.bt_scan})
    public void onViewClick(View view){
        switch (view.getId()) {
          //跳转“载入扫描页面”
            case R.id.bt_scan:
                load();
                break;
        }
    }

    private void load() {
        //showWaitingDialog("载入中...");
        if(!v_fileName.isEmpty() ){
            if(fileNameList.size() > 0 ){
                Bundle bd = new Bundle();
                bd.putString("fileName",v_fileName);
                jumpToActivityTakeByAndClearTop(RepeatScanActivity.class,bd);

            }else{
                showMessage(UIUtil.getString(R.string.nofile));
            }

        }else{
            showMessage(UIUtil.getString(R.string.tag_need));
        }
    }

    public List<Product_fwqd> getFwqdXmlModel(List<Product_fwqd>  mList ){
        List<Product_fwqd>  list = new ArrayList<>();
        for(Product_fwqd bean : mList){
           /*Product_fwqd pro_Fwqd = new Product_fwqd();
            JpTabFwqd _fwqd = new JpTabFwqd();
            _fwqd.setGznd(bean.get_fwqd().getGznd());
            _fwqd.setYsjhbh(bean.get_fwqd().getYsjhbh());
            _fwqd.setQdh(bean.get_fwqd().getQdh());
            pro_Fwqd.set_fwqd(_fwqd);
            ProductEpc pro = new ProductEpc();
            pro.setStrEpc(bean.get_pro().getStrEpc());
            pro.getInfoFormEpc();
            pro.setStrWzName((bean.get_pro().getStrWzName()));
            pro.setStrWzHXName((bean.get_pro().getStrWzHXName()));
            pro_Fwqd.set_pro(pro);

            pro_Fwqd.setOldYsjhbh(bean.getOldYsjhbh());
            pro_Fwqd.setOldQdh(bean.getOldQdh());*/

            bean.get_pro().getInfoFormEpc();
            list.add(bean);
        }
        return list;

    }

    private View.OnClickListener onClickListener = new View.OnClickListener() {

        @Override
        public void onClick(View view) {
            LinearLayout btn = (LinearLayout) view;
            int pos = (Integer) btn.getTag();
            v_fileName = fileNameList.get(pos).toString();
            for(int i=0;i<fileNameList.size();i++){
                LinearLayout layout = (LinearLayout)item_lv.getChildAt(i);// 获得子item的layout
                LinearLayout fileNmae_ly = (LinearLayout) layout.findViewById(R.id.fileNmae_ly);// 从l
                if(pos == i){
                    fileNmae_ly.setBackgroundColor(UIUtil.getColor(R.color.colorAccent));
                }else {
                    fileNmae_ly.setBackgroundColor(UIUtil.getColor(R.color.white));
                }
            }
        }
    };
}

