package com.junmp.print.ui.matcheck.repeat.list;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqdBean;
import com.junmp.print.util.UIUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/1
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RepeatListAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;

    public List<String> data;

    private View.OnClickListener onClickListener;
    public RepeatListAdapter(Context context, List<String> data,
                             View.OnClickListener onClickListener) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.onClickListener = onClickListener;
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public Object getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_check_repeat_list_item, null);

            holder = new ViewHolder();

            holder.fileName_tv = convertView.findViewById(R.id.fileName_tv);
            holder.fileNmae_ly = convertView.findViewById(R.id.fileNmae_ly);


            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        String mInfo = data.get(position);

        if (mInfo != null) {

            holder.fileName_tv.setText(mInfo);

            holder.fileNmae_ly.setTag(position);
            holder.fileNmae_ly.setOnClickListener(this.onClickListener);
        }

        return convertView;
    }

    static class ViewHolder {

        TextView fileName_tv;

        LinearLayout fileNmae_ly;
    }

}

