package com.junmp.print.ui.matcheck.repeat.scan;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.util.Xml;
import android.view.KeyEvent;
import android.view.View;
import android.widget.AbsListView;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.entity.Product_fwqd;
import com.junmp.print.iview.IRepeatScanView;
import com.junmp.print.presenter.RepeatScanPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.util.LogUtils;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.Util;
import com.junmp.print.view.MyListView;
import com.uhf.scanlable.UHfData;

import org.xmlpull.v1.XmlPullParser;

import java.io.File;
import java.io.FileInputStream;
import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import butterknife.BindView;
import butterknife.OnClick;
/**
 * <pre>
 * 描述：载入扫描页面
 * 版本：1.0
 * 日期：2018/4/26
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RepeatScanActivity extends BaseActivity<IRepeatScanView,RepeatScanPresenter> implements IRepeatScanView {

    @BindView(R.id.bt_scan)
    TextView bt_start;

    @BindView(R.id.bt_scanEnd)
    TextView bt_end;

    @BindView(R.id.re_list_lv)
    MyListView item_lv;

    @BindView(R.id.scrollView)
    ScrollView scrollView;

    @BindView(R.id.fileName)
    TextView fileName_tv;
    String v_pathName = Environment.getExternalStorageDirectory()+"/JPQYHand/ErrorXml/";
    String v_fileName = "";
    Boolean isRead = false;
    private List<String> doneEpcsList = new ArrayList<>();
    List<ProductEpc> productMxListItems = new ArrayList<>();
    List<ProductEpc> productMxListItemsForLv = new ArrayList<>();
    private RepeatScanAdapter repeatApapter = null;


    List<Product_fwqd> mList = new ArrayList<>() ;
    List<Product_fwqd> listFor = new ArrayList<>() ;
    String strMsg = "";
    boolean isInit = false;
    boolean isFirst = false;

    private int startIndex;
    private int endIndex;
    private final int pageSize = 15;

    Handler handler = new Handler();
    private boolean isInventory = false;

    private Handler mHandler;
    private boolean isCanceled = true;
    private int MESSAGE_SUCCESS = 0;
    private int MESSAGE_FAIL = 1;
    private String devport = "/dev/ttyMT1";
    private static final int MSG_UPDATE_LISTVIEW = 0;
    private static final int SCAN_INTERVAL = 5;
    private Timer timer;


    /**
     * key receiver
     */
    private long startTime = 0;
    private boolean keyUpFalg = true;
    private BroadcastReceiver keyReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            int keyCode = intent.getIntExtra("keyCode", 0);
            // H941
            if (keyCode == 0) {
                keyCode = intent.getIntExtra("keycode", 0);
            }
            boolean keyDown = intent.getBooleanExtra("keydown", false);
            if (keyUpFalg && keyDown && System.currentTimeMillis() - startTime > 500) {
                keyUpFalg = false;
                startTime = System.currentTimeMillis();
                /*if (keyCode == KeyEvent.KEYCODE_F3) {
                    onClick(scan);
                }*/

                if (keyCode == KeyEvent.KEYCODE_F3 && isInventory){
                    bt_end.performClick();
                }
                else if (keyCode == KeyEvent.KEYCODE_F3 && !isInventory){
                    bt_start.performClick();
                }
                return;
            } else if (keyDown) {
                startTime = System.currentTimeMillis();
            } else {
                keyUpFalg = true;
            }

        }
    };


    @Override
    protected void onResume() {
        super.onResume();

        UHfData.lsTagList.clear();
        UHfData.dtIndexMap.clear();

        IntentFilter filter = new IntentFilter();
        filter.addAction("android.rfid.FUN_KEY");
        registerReceiver(keyReceiver, filter);
    }

    @Override
    protected void onPause() {
        super.onPause();
        unregisterReceiver(keyReceiver);
    }

    private ConnectHandler connectHandler = new ConnectHandler(this);

    private static class ConnectHandler extends Handler {
        private WeakReference<RepeatScanActivity> mReference;
        private RepeatScanActivity mActivity;

        ConnectHandler(RepeatScanActivity activity) {
            mReference = new WeakReference<RepeatScanActivity>(activity);
            mActivity = mReference.get();
        }

        @Override
        public void handleMessage(Message msg) {
            if (msg.what == mActivity.MESSAGE_SUCCESS) {
                Toast.makeText(mActivity.getApplicationContext(), mActivity.getString(R.string.port_connect_success),
                        Toast.LENGTH_SHORT).show();
            } else if (msg.what == mActivity.MESSAGE_FAIL) {
                Toast.makeText(mActivity.getApplicationContext(), mActivity.getString(R.string.port_connect_fail),
                        Toast.LENGTH_SHORT).show();
            }
            super.handleMessage(msg);
        }
    }


    public void initView() {
        isInit = true;
        isFirst = true;
        this.bt_end.setEnabled(false);
        Bundle bundle = getIntent().getExtras();
        v_fileName = bundle.getString("fileName");
        fileName_tv.setText(v_fileName);

        item_lv.setScrollView(scrollView);

        startIndex = 0;
        endIndex = pageSize;

        getXml();

        mHandler = new Handler() {
            @Override
            public void handleMessage(Message msg) {
                if (isCanceled)
                    return;
                switch (msg.what) {
                    case MSG_UPDATE_LISTVIEW://数据更新

                        if (UHfData.lsTagList.size() > 0) {
                            parseData();
                        }
                        if (UHfData.mIsNew) {
                            new Thread(new Runnable() {

                                @Override
                                public void run() {
                                    if (!Util.soundfinished)
                                        Util.play(1, 0);
                                }
                            }).start();
                            UHfData.mIsNew = false;
                        }
                        break;
                    default:
                        break;
                }
                super.handleMessage(msg);
            }

        };
        Util.initSoundPool(this);
    }
    private void getXml() {
        try{
            String fileNameXml = v_pathName + v_fileName;
            File file = new File(fileNameXml);
            FileInputStream fis = new FileInputStream(file);
            //获取Xml的pull解析器
            XmlPullParser xp = Xml.newPullParser();

            ///初始化xmlPull解析器
            //指定使用什么编码去解析xml文件
            xp.setInput(fis,"gb2312");
            //开始解析
            //需要判断当前解析到什么标签，因为解析到不同的标签需要做不同的操作
            //获取当前标签的事件类型
            int type = xp.getEventType();
            Product_fwqd pro_Fwqd = null;
            JpTabFwqd _fwqd = null;
            ProductEpc _pro = null;
            int count = 0;

            while (type!=XmlPullParser.END_DOCUMENT){
                switch (type) {
                    case XmlPullParser.START_TAG:
                        if ("EPCLIST".equals(xp.getName())) {//获取当前标签的名字
                            mList = new ArrayList<>();
                            Product_fwqd pro_Fwqd0 = new Product_fwqd();
                            ProductEpc _pro0 = new ProductEpc();
                            _pro0.setListIndex(count);
                            _pro0.setStrWzName("品名");
                            _pro0.setStrWzHXName("号型");
                            _pro0.setStrScrq("生产日期");
                            _pro0.setStrNum("数量");
                            _pro0.setStrXiangNo("箱号");
                            pro_Fwqd0.setOldYsjhbh("原运输计划");
                            pro_Fwqd0.setOldQdh("原清单号");
                            pro_Fwqd0.set_pro(_pro0);
                            pro_Fwqd0.setCount(0);
                            mList.add(pro_Fwqd0);
                        } else if ("INFO".equals(xp.getName())) {//获取当前标签的名字
                            pro_Fwqd = new Product_fwqd();
                            _fwqd = new JpTabFwqd();
                            _pro = new ProductEpc();
                        } else if ("Gznd".equals(xp.getName())) {
                            String Gznd = xp.nextText();//获取当前节点的下一个节点的文本，并把指针移动至当前节点的结束节点
                            _fwqd.setGznd(Gznd);
                        } else if ("Ysjhbh".equals(xp.getName())) {
                            String Ysjhbh = xp.nextText();
                            _fwqd.setYsjhbh(Ysjhbh);
                        } else if ("Qdh".equals(xp.getName())) {
                            String Qdh = xp.nextText();
                            _fwqd.setQdh(Qdh);
                        } else if ("EPC".equals(xp.getName())) {
                            String EPC = xp.nextText();
                            _pro.setStrEpc(EPC);
                        } else if ("WzName".equals(xp.getName())) {
                            String wzmc = xp.nextText();
                            _pro.setStrWzName(wzmc);
                        } else if ("HXName".equals(xp.getName())) {
                            String wzhx = xp.nextText();
                            _pro.setStrWzHXName(wzhx);
                        }else if ("DtScrq".equals(xp.getName())) {
                            String DtScrq = xp.nextText() + " 00-00-00";
                            int date = TimeUtil.getDateInt(DtScrq);
                            _pro.setDtScrq(date);
                        }else if ("Xiang".equals(xp.getName())) {
                            String xh = xp.nextText();
                            _pro.setStrXiangNo(xh);
                        }else if ("oldYsjhbh".equals(xp.getName())) {
                            String oldYsjhbh = xp.nextText();
                            pro_Fwqd.setOldYsjhbh(oldYsjhbh);
                        }else if ("oldQdh".equals(xp.getName())) {
                            String oldQdh = xp.nextText();
                            pro_Fwqd.setOldQdh(oldQdh);
                        }
                        break;
                    case XmlPullParser.END_TAG:
                        if ("INFO".equals(xp.getName())) {
                            pro_Fwqd.set_fwqd(_fwqd);
                            count ++;
                            _pro.setListIndex(count);
                            //_pro.getInfoFormEpc();
                            pro_Fwqd.set_pro(_pro);
                            pro_Fwqd.setCount(0);
                            mList.add(pro_Fwqd);
                            productMxListItems.add(_pro);
                        }
                        break;
                }
                //指针移动至下一个节点，并且获取它的事件类型
                type = xp.next();
            }
            if( mList.size() >0){

                showList(mList);
            }else{
                showMessage(UIUtil.getString(R.string.fail_data_null));
            }

        }catch (Exception e){
            showMessage("Err:"+e.getMessage());
        }
    }

    private void showList(List<Product_fwqd> mList) {
        listFor.addAll(getDataService(0,pageSize));
        repeatApapter = new RepeatScanAdapter(this,listFor);
        item_lv.setAdapter(repeatApapter);
        item_lv.setOnScrollListener(new ScrollListener());
        //setListViewHeightBasedOnChildren(item_lv);

    }

    @Override
    protected RepeatScanPresenter createPresenter() {
        return new RepeatScanPresenter(this);
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_check_repeat_scan;
    }

    @OnClick({R.id.bt_scan,R.id.bt_scanEnd})
    public void onViewClick(View view){
        switch (view.getId()) {
            //扫描
            case R.id.bt_scan:
                startScan();
                break;
            //扫描
            case R.id.bt_scanEnd:
                stopScan();
                break;
        }
    }

    private void startScan() {
        try {
            //if (!TextUtils.isEmpty(strMsg)) {
            isInventory = false;
            doTagInventory();
            showMessage(UIUtil.getString(R.string.start_scan));
            isRead = true;
            this.bt_start.setEnabled(false);
            this.bt_start.setBackgroundColor(UIUtil.getColor(R.color.green_bt_unEnable));
            this.bt_end.setEnabled(true);
            this.bt_end.setBackgroundColor(UIUtil.getColor(R.color.green_bt));
        } catch (Exception ex) {
            showMessage("ERR：" + ex.getMessage());
        }
    }

    private void stopScan() {
        try {
            doTagInventory();
            isInventory = false;
            showMessage(UIUtil.getString(R.string.stop_scan));
            isRead = false;
            this.bt_start.setEnabled(true);
            this.bt_start.setBackgroundColor(UIUtil.getColor(R.color.green_bt));
            this.bt_end.setEnabled(false);
            this.bt_end.setBackgroundColor(UIUtil.getColor(R.color.green_bt_unEnable));
        } catch (Exception ex) {
            showMessage("ERR：" + ex.getMessage());
        }
    }

    public void doTagInventory() {
        isInventory = !isInventory;
        if (timer == null && isInventory) {//盘点开始
            isCanceled = false;
            timer = new Timer();
            timer.schedule(new TimerTask() {
                @Override
                public void run() {
                    UHfData.Inventory_6c(255, 0);//0单标签，1多标签；255自动；是否盘存TID，0—否，1—是，值为1时盘存到的为标签的TID
//						UHfData.Inventory_6c_Mask((byte)0, 16, 0, UHfGetData.hexStringToBytes("E200"));
                    mHandler.removeMessages(MSG_UPDATE_LISTVIEW);
                    mHandler.sendEmptyMessage(MSG_UPDATE_LISTVIEW);
                }
            }, 0, SCAN_INTERVAL);
            showMessage("正在盘点");
        } else {//盘点停止
            isCanceled = true;
            if (timer != null) {
                timer.cancel();
                timer = null;
                showMessage("结束盘点");
            }
        }
    }

    int tagListSize = 0;//个数
    int ListIndex = 0;
    private void parseData() {
            try {
                int doSize = 0;//个数
                String epcstr = "";//epc

                if(UHfData.lsTagList.size() > tagListSize ){
                    doSize = UHfData.lsTagList.size() - tagListSize;//等待处理的epc
                    tagListSize = UHfData.lsTagList.size();
                }
                if (doSize > 0)
                    while (doSize > 0) {
                        epcstr = UHfData.lsTagList.get(ListIndex).strEPC;
                        epcstr = String.valueOf(epcstr.replace(" ", ""));

                            if(!doneEpcsList.contains(epcstr)){//已经处理的epc列表中不包含这个
                                ProductEpc product = new ProductEpc();
                                product.setStrEpc(epcstr);
                                product.getInfoFormEpc();
                                if(product.getStrEpc().substring(0,2).equals("05") && product.getStrTagType().equals("1")
                                        && !product.getStrNum().equals("000")){
                                    tagMethod(product);
                                }
                                doneEpcsList.add(epcstr);
                            }

                        ListIndex++;
                        doSize--;
                    }
            } catch (NumberFormatException e) {
                e.printStackTrace();
            }
            if (!isInventory)
                showMessage(UIUtil.getString(R.string.wait_todo));
    }

    /**显示扫描到的标签信息*/
    private void tagMethod(ProductEpc pro) {
        ProductEpc foundData = null;
        for(ProductEpc pe : productMxListItems ){
            if(pe.getStrEpc().equals(pro.getStrEpc()) ){
                foundData = pe;
                break;
            }
        }
        if(foundData != null){
            //仅能识别在重复清单的epc
            try{
                pro.setListIndex(foundData.getListIndex());
                loadProductToList(pro,"N");
            }catch (Exception e){

            }
        }

    }

    private void loadProductToList(ProductEpc pro, String n) {
        try{
            int count = repeatApapter.getItem(pro.getListIndex()).get_pro().getListIndex();
            mList.get(pro.getListIndex()).setCount(count);
            if(listFor.size() >= pro.getListIndex()){
                repeatApapter.updataView(pro.getListIndex(),item_lv,listFor.get(pro.getListIndex()));
            }
            //repeatApapter.notifyDataSetChanged();
            //item_lv.setAdapter(repeatApapter);
        }catch (Exception e){

        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (event.getScanCode() == 261 && isInventory){
            bt_end.performClick();
        }
        else if (event.getScanCode() == 261 && !isInventory){
            bt_start.performClick();
        }

        return super.onKeyDown(keyCode, event);
    }

    public final class ScrollListener implements AbsListView.OnScrollListener {
        boolean isLastRow = false;
        @Override
        public void onScrollStateChanged(AbsListView view, int scrollState) {
            LogUtils.e("---->" + scrollState);
            switch (scrollState) {
                case SCROLL_STATE_IDLE://滚到底部
                    if(isLastRow){
                        showMessage("");
                        if(view.getCount() < mList.size()){//没有加载全部数据的时候
                            startIndex += pageSize;
                            endIndex += pageSize;
                            listFor.addAll( getDataService(startIndex, endIndex));
                            repeatApapter.notifyDataSetChanged();

                        }else{
                            showMessage("数据已经加载完全！");
                        }
                        isLastRow = false;
                    }
                    break;
                case SCROLL_STATE_TOUCH_SCROLL:
                    break;
                case SCROLL_STATE_FLING:
                    break;
            }
            //当滚动到最后一行且停止滚动时，执行加载

        }

        @Override
        public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
            if(firstVisibleItem + visibleItemCount == totalItemCount && totalItemCount > 0 ) {
                isLastRow = true;
            }
        }

    }

    /**
     * 加载显示数据
     * @param from
     * @param to
     * @return
     */
    public List<Product_fwqd> getDataService(int from, int to) {
        List<Product_fwqd> productfor = new ArrayList<>();
        if(to>mList.size()){
            to = mList.size();
            endIndex = to;
            startIndex = to -pageSize;
        }
        for (int i = from; i < to; i++) {
            productfor.add(mList.get(i));
        }
        LogUtils.d("加载数据：" + Integer.toString(productfor.size()));
        return productfor;
    }

}
