package com.junmp.print.ui.set.password;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.TextView;

import com.junmp.print.PrintApplication;
import com.junmp.print.R;
import com.junmp.print.app.UserCache;
import com.junmp.print.dao.entity.JpTabConfig;
import com.junmp.print.dao.service.JpTabConfigService;
import com.junmp.print.iview.IPasswordView;
import com.junmp.print.presenter.PasswordPresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.UIUtil;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：修改密码
 * 版本：1.0
 * 日期：2018/4/26
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class PasswordFragment extends BaseFragment<IPasswordView, PasswordPresenter> implements IPasswordView {

    @BindView(R.id.oldPass_et)
    EditText oldPass_et;

    @BindView(R.id.newPass_et)
    EditText newPass_et;

    @BindView(R.id.newPassAgain_et)
    EditText newPassAgain_et;

    JpTabConfigService jpTabConfigService = new JpTabConfigService();

    @Override
    protected int setView() {
        return R.layout.fragment_set_password;
    }

    @Override
    protected void init(View view) {
    }

    @Override
    protected void intView(View view) {

    }

    @Override
    protected PasswordPresenter createPresenter() {
        return new PasswordPresenter(this);
    }

    @OnClick({R.id.bt_changePass})
    public void onViewClick(View view){
        switch (view.getId()) {
            //修改密码
            case R.id.bt_changePass:
                changePass();
                break;
        }
    }

    /**
     * 修改密码
     * */
    private void changePass() {
        String oldPass = oldPass_et.getText().toString();
        String newPass = newPass_et.getText().toString();
        String newPassAgain = newPassAgain_et.getText().toString();
        try{
            JpTabConfig jpTabConfig = new JpTabConfig();
            jpTabConfig = (JpTabConfig) jpTabConfigService.getConfigByid(UserCache.getId());
            if(UserCache.getPassWord().equals(oldPass)){
               if(newPass.equals(newPassAgain) ){
                   if(newPass.length()>0){
                           jpTabConfig.setStrpass(newPass);
                           boolean flag = jpTabConfigService.update(jpTabConfig);
                           if(flag){
                               UserCache.savePassWord(newPass);
                               showMessage(UIUtil.getString(R.string.change_pass_success));
                           }else{
                               showMessage(UIUtil.getString(R.string.change_pass_fail));
                           }

                   }else{
                       showMessage(UIUtil.getString(R.string.pass_not_empty));
                   }
               }else{
                   showMessage(UIUtil.getString(R.string.pass_not_passAgain));
                   newPass_et.setText("");
                   newPassAgain_et.setText("");
                   newPass_et.setFocusable(true);
               }
            }else{
                showMessage(UIUtil.getString(R.string.oldPass_ill));
                oldPass_et.setText("");
                oldPass_et.setFocusable(true);
            }
            }catch (Exception e){
            showMessage("Err:"+e.getMessage());
        }

    }

    public void clean(){
        oldPass_et.setText("");
        newPass_et.setText("");
        newPassAgain_et.setText("");
    }

}

