package com.junmp.print.util;


import org.bouncycastle.util.encoders.Base64;


public class SecurityUtil {


    public static final String CHARSET = "UTF-8";

    /**
     * Base64 解码
     *
     * @param key
     * @return
     */
    public static byte[] decryptBase64(String key) {
        try {
            return Base64.decode(key);
        } catch (Exception ex) {
            throw new RuntimeException("Base64解码错误");
        }
    }

    /**
     * Base64 编码
     *
     * @param key
     * @return
     */
    public static byte[] encryptBase64(byte[] key) {
        try {
            return Base64.encode(key);
        } catch (Exception ex) {
            throw new RuntimeException("Base64编码错误");
        }
    }

    /**
     * Base64 编码
     *
     * @param key
     * @return
     */
    public static byte[] encryptBase64(String key) {
        try {
            return encryptBase64(key.getBytes(CHARSET));
        } catch (Exception ex) {
            throw new RuntimeException("Base64编码错误");
        }
    }

    /**
     * Base64 编码
     *
     * @param key
     * @return
     */
    public static String encryptBase64String(String key) {
        try {
            return new String(encryptBase64(key));
        } catch (Exception ex) {
            throw new RuntimeException("Base64编码错误");
        }
    }


    /**
     * 获取数据的签名
     *
     * @param data 需要签名的业务数据
     * @return
     */
    public static String getSign(String data) {
        StringBuffer sb = new StringBuffer();
        try {
            //sb.append(AppConstants.APP_SECRET).append(data).append(AppConstants.APP_SECRET);
            String temp = sb.toString();
            //LogUtil.i("签名字符：" + temp);
            //1.对数据base64编码
            String base64 = encryptBase64String(temp);
            //LogUtil.i("base64:" + base64);
            //2.对base64编码做MD5加密输出小写
            return EncryptUtils.encryptMD5ToString(base64).toLowerCase();
            //return Md5Util.md5(base64).toLowerCase();
        } catch (Exception ex) {
            return null;
        }
    }


}

