package com.junmp.print.util;

import android.util.SparseArray;
import android.view.View;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/2/7
 * 作者：ningzp@junmp.com.cn
 * </pre>
 */

public class ViewFindUtil {

    public static <T extends View> T hold(View view, int id) {
        SparseArray<View> viewHolder = (SparseArray<View>) view.getTag();

        if (viewHolder == null) {
            viewHolder = new SparseArray<View>();
            view.setTag(viewHolder);
        }

        View childView = viewHolder.get(id);

        if (childView == null) {
            childView = view.findViewById(id);
            viewHolder.put(id, childView);
        }

        return (T) childView;
    }

    /**
     * 替代findviewById方法
     */
    public static <T extends View> T find(View view, int id) {
        return (T) view.findViewById(id);
    }
}
