package com.junmp.print.util;

import android.Manifest;
import android.content.Intent;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Environment;
import android.util.Xml;

import com.junmp.print.PrintApplication;
import com.junmp.print.app.UserCache;
import com.junmp.print.dao.entity.JpTabFwqdjy;
import com.junmp.print.dao.entity.JpTabWzjy;
import com.junmp.print.dao.entity.Product_fwqd;

import org.xmlpull.v1.XmlSerializer;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/31
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class XMLUtil {

    /**
     * 将校验数据导出到xml
     * */
    public static String createXml(List<JpTabFwqdjy> listjy,String uploadname,String jsswmc,String ver) throws IOException {
        FileOutputStream fos = null;
        //String headerNmae = errList.get(0).get_fwqd().getQdh();
        String fileName = Environment.getExternalStorageDirectory()+"/JPQYHand/" + uploadname + "/";
        try{

            File path = new File(fileName);

            if(!path.exists()){
                path.mkdir();
            }
            fileName = fileName + jsswmc + "_" + TimeUtil.getDateLongNo()+".xml";
            //   Environment.getExternalStorageDirectory()  mnt/sdcard/ 即为SD卡根路径
            File file = new File(fileName);
            fos = new FileOutputStream(file);
            // 获得一个序列化工具
            XmlSerializer serializer = Xml.newSerializer();
            serializer.setOutput(fos, "gb2312");
            // 设置文件头
            serializer.startDocument("gb2312", true);
            serializer.startTag(null, "list");
            serializer.startTag(null, "INFO");

            serializer.startTag(null, "Ver");
            serializer.text(ver);
            serializer.endTag(null, "Ver");

            serializer.startTag(null, "Total");
            serializer.text(String.valueOf(listjy.size()));
            serializer.endTag(null, "Total");
            serializer.endTag(null, "INFO");
            for(JpTabFwqdjy bean:listjy){
                serializer.startTag(null, "VIE_BZGL_FWQD");
                //serializer.attribute(null, "id", String.valueOf(person.getId()));

                serializer.startTag(null, "gznd");
                serializer.text(bean.getGznd());
                serializer.endTag(null, "gznd");

                serializer.startTag(null, "qydwdm");
                serializer.text(bean.getQydwdm());
                serializer.endTag(null, "qydwdm");

                serializer.startTag(null, "ysjhbh");
                serializer.text(bean.getYsjhbh());
                serializer.endTag(null, "ysjhbh");

                serializer.startTag(null, "qdh");
                serializer.text(bean.getQdh());
                serializer.endTag(null, "qdh");

                serializer.startTag(null, "swdwdm");
                serializer.text(bean.getSwdwdm());
                serializer.endTag(null, "swdwdm");

                serializer.startTag(null, "jsdwdm");
                serializer.text(bean.getJsdwdm());
                serializer.endTag(null, "jsdwdm");

                serializer.startTag(null, "dtpdate");
                serializer.text(bean.getDtpdate());
                serializer.endTag(null, "dtpdate");

                serializer.startTag(null, "epc1");
                serializer.text(bean.getStrepc());
                serializer.endTag(null, "epc1");

                serializer.startTag(null, "epc2");
                serializer.text(bean.getStrepc1());
                serializer.endTag(null, "epc2");

                serializer.startTag(null, "epc3");
                serializer.text(bean.getStrepc2());
                serializer.endTag(null, "epc3");

                serializer.startTag(null, "epc4");
                serializer.text(bean.getStrepc3());
                serializer.endTag(null, "epc4");

                serializer.startTag(null, "lsm");
                serializer.text(bean.getLsm());
                serializer.endTag(null, "lsm");
/*
                serializer.startTag(null, "Pmsl");
                serializer.text(bean.getPmsl());
                serializer.endTag(null, "Pmsl");

                serializer.startTag(null, "IsOut");
                serializer.text(bean.getIsOut());
                serializer.endTag(null, "IsOut");

                serializer.startTag(null, "IsOk");
                serializer.text(bean.getIsOk());
                serializer.endTag(null, "IsOk");

                serializer.startTag(null, "subEpc");
                serializer.text(bean.getSubEpc());
                serializer.endTag(null, "subEpc");*/

                serializer.endTag(null, "VIE_BZGL_FWQD");
            }
            serializer.endTag(null, "list");
            serializer.endDocument();
            fos.flush();
            return fileName;
        }catch(Exception e){
            return null;
        }finally {
            fos.close();
        }
    }

    /**
     * 将错误数据（productepc）导出到xml
     * */
    public static String createXml(List<Product_fwqd> errList) throws IOException {
        FileOutputStream fos = null;
        String headerNmae = errList.get(0).get_fwqd().getQdh();
        String fileName = Environment.getExternalStorageDirectory()+"/JPQYHand/ErrorXml/";
        try{

            File path = new File(fileName);

            if(!path.exists()){
                path.mkdir();
            }
            fileName = fileName + headerNmae + "-ERR-" + TimeUtil.getDateLong()+".xml";
            //   Environment.getExternalStorageDirectory()  mnt/sdcard/ 即为SD卡根路径
            File file = new File(fileName);
            fos = new FileOutputStream(file);
            // 获得一个序列化工具
            XmlSerializer serializer = Xml.newSerializer();
            serializer.setOutput(fos, "gb2312");
            // 设置文件头
            serializer.startDocument("gb2312", true);
            serializer.startTag(null, "EPCLIST");
            for(Product_fwqd bean:errList){
                //headerNmae = bean.get_fwqd().getQdh();
                serializer.startTag(null, "INFO");
                //serializer.attribute(null, "id", String.valueOf(person.getId()));

                serializer.startTag(null, "Gznd");
                serializer.text(bean.get_fwqd().getGznd());
                serializer.endTag(null, "Gznd");

                serializer.startTag(null, "Ysjhbh");
                serializer.text(bean.get_fwqd().getYsjhbh());
                serializer.endTag(null, "Ysjhbh");

                serializer.startTag(null, "Qdh");
                serializer.text(bean.get_fwqd().getQdh());
                serializer.endTag(null, "Qdh");

                serializer.startTag(null, "EPC");
                serializer.text(bean.get_pro().getStrEpc());
                serializer.endTag(null, "EPC");

                serializer.startTag(null, "WzName");
                serializer.text(bean.get_pro().getStrWzName());
                serializer.endTag(null, "WzName");

                serializer.startTag(null, "HXName");
                serializer.text(bean.get_pro().getStrWzHXName());
                serializer.endTag(null, "HXName");

                serializer.startTag(null, "DtScrq");
                serializer.text(TimeUtil.getDateStringShort(bean.get_pro().getDtScrq()));
                serializer.endTag(null, "DtScrq");

                serializer.startTag(null, "Xiang");
                serializer.text(String.valueOf(bean.get_pro().getiXangNo()));
                serializer.endTag(null, "Xiang");

                serializer.startTag(null, "oldYsjhbh");
                serializer.text(bean.getOldYsjhbh());
                serializer.endTag(null, "oldYsjhbh");

                serializer.startTag(null, "oldQdh");
                serializer.text(bean.getOldQdh());
                serializer.endTag(null, "oldQdh");

                serializer.endTag(null, "INFO");
            }
            serializer.endTag(null, "EPCLIST");
            serializer.endDocument();
            fos.flush();
            fos.close();
            return fileName;
        }catch(Exception e){
            return null;
        }finally {
            fos.close();
        }
    }

    /**
     * 将随机校验数据导出到xml
     * */
    public static String createXmlTags(List<JpTabWzjy> list) throws IOException {
        FileOutputStream fos = null;
        String fileName = Environment.getExternalStorageDirectory()+ "/JPQYHand/TagsXml/";
        try{

            File path = new File(fileName);

            if(!path.exists()){
                path.mkdir();
            }
            fileName = fileName + TimeUtil.getDateLongNo()+".xml";
            //   Environment.getExternalStorageDirectory()  mnt/sdcard/ 即为SD卡根路径
            File file = new File(fileName);
            fos = new FileOutputStream(file);
            // 获得一个序列化工具
            XmlSerializer serializer = Xml.newSerializer();
            serializer.setOutput(fos, "gb2312");
            // 设置文件头
            serializer.startDocument("gb2312", true);
            serializer.startTag(null, "Tags");
            for(JpTabWzjy bean:list){
                serializer.startTag(null, "tag");
                //serializer.attribute(null, "id", String.valueOf(person.getId()));

                serializer.startTag(null, "epc");
                serializer.text(bean.getStrwzepc());
                serializer.endTag(null, "epc");

                serializer.endTag(null, "tag");
            }

            serializer.endTag(null, "Tags");
            serializer.endDocument();
            fos.flush();
            return fileName;
        }catch(Exception e){
            return null;
        }finally {
            fos.close();
        }
    }
}
